package org.gvsig.mobile.app;

import org.gvsig.compat.CompatLibrary;
import org.gvsig.compat.me.MECompatLibrary;
import org.gvsig.fmap.dal.DALLibrary;
import org.gvsig.fmap.dal.impl.DALDefaultImplLibrary;
import org.gvsig.fmap.dal.index.spatial.jts.JTSIndexLibrary;
import org.gvsig.fmap.dal.store.memory.MemoryStoreLibrary;
import org.gvsig.fmap.geom.GeometryLibrary;
import org.gvsig.fmap.geom.impl.DefaultGeometryLibrary;
import org.gvsig.fmap.geom.operation.impl.MEGeometryOperationLibrary;
import org.gvsig.fmap.mapcontext.MapContextLibrary;
import org.gvsig.fmap.mapcontext.impl.MapContextImplLibrary;
import org.gvsig.metadata.MetadataLibrary;
import org.gvsig.metadata.lib.basic.impl.BasicMetadataLibrary;
import org.gvsig.mobile.core.GvsigCoreLibrary;
import org.gvsig.mobile.core.libraries.LibrariesManager;
import org.gvsig.mobile.symbology.SimpleSymbologyLibrary;
import org.gvsig.tools.ToolsLibrary;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.persistence.xml.XMLPersistenceManager;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {	
		
		// from dal file
		ToolsLibrary lib = new  ToolsLibrary();
		LibrariesManager.getInstance().registerLibrary(lib);
		
		CompatLibrary cl = new CompatLibrary();
		LibrariesManager.getInstance().registerLibrary(cl);

		MECompatLibrary mecoli = new MECompatLibrary();
		LibrariesManager.getInstance().registerLibrary(mecoli);
		
		MetadataLibrary mdlib = new MetadataLibrary();
		LibrariesManager.getInstance().registerLibrary(mdlib);
		
		BasicMetadataLibrary smdlib = new BasicMetadataLibrary();
		LibrariesManager.getInstance().registerLibrary(smdlib);
		
		GeometryLibrary gl = new GeometryLibrary();
		LibrariesManager.getInstance().registerLibrary(gl);
		
		DefaultGeometryLibrary dgl = new DefaultGeometryLibrary();
		LibrariesManager.getInstance().registerLibrary(dgl);
		
		MEGeometryOperationLibrary megol = new MEGeometryOperationLibrary();
		LibrariesManager.getInstance().registerLibrary(megol);
		
		DALLibrary dall =new DALLibrary();
		LibrariesManager.getInstance().registerLibrary(dall);
		
		DALDefaultImplLibrary daldl =new DALDefaultImplLibrary();
		LibrariesManager.getInstance().registerLibrary(daldl);
		
//		MemoryStoreLibrary msLib = new MemoryStoreLibrary(); 
//		LibrariesManager.getInstance().registerLibrary(msLib);
		
		// ===============================================================
		// ===============================================================
		// ===============================================================
		
		
		//Initialize Libraries
		MapContextLibrary mclib = new MapContextLibrary();
		LibrariesManager.getInstance().registerLibrary(mclib);

		MapContextImplLibrary mcilib = new MapContextImplLibrary();
		LibrariesManager.getInstance().registerLibrary(mcilib);		
		
		// this would use ZIP manager
		// XMLPersistenceLibrary xmlpe = new XMLPersistenceLibrary();
		// LibrariesManager.getInstance().registerLibrary(xmlpe);
		
		SimpleSymbologyLibrary slib = new SimpleSymbologyLibrary();
		LibrariesManager.getInstance().registerLibrary(slib);
		
		JTSIndexLibrary jts = new JTSIndexLibrary();
		LibrariesManager.getInstance().registerLibrary(jts);
		
		// direct registering to avoid ZIP manager :-/
		ToolsLocator.registerPersistenceManager(XMLPersistenceManager.class);
		
		GvsigCoreLibrary corelib = new GvsigCoreLibrary();
		LibrariesManager.getInstance().registerLibrary(corelib);

//		// ======================== GPE LIB
//		// /*
//		DefaultGPELibrary defaultGPElibrary = new DefaultGPELibrary();
//		LibrariesManager.getInstance().registerLibrary(defaultGPElibrary);
//
//		// DefaultGPEDataTypesLibrary gpeDataTypesLibrary = new DefaultGPEDataTypesLibrary();
//		// LibrariesManager.getInstance().registerLibrary(gpeDataTypesLibrary);
//		
//		XmlLibrary defaultXmllibrary = new XmlLibrary();
//		LibrariesManager.getInstance().registerLibrary(defaultXmllibrary);
//		
//		KmlLibrary kmlLibrary = new KmlLibrary();
//		LibrariesManager.getInstance().registerLibrary(kmlLibrary);
//		
//		GmlLibrary gmlLibrary = new GmlLibrary();
//		LibrariesManager.getInstance().registerLibrary(gmlLibrary);
//		// */
//		// ======================== GPE LIB


		
	}

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
	}
}
