package org.gvsig.mobile.core.auxfunctions;

import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.gvsig.mobile.core.extensions.interfaces.IFileType;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

public class FileTypeResolutor {
	
	public static final String  ACTION_READ_PARAMETER_KEY = "READ_CAPABLE"; 
	public static final String  ACTION_WRITE_PARAMETER_KEY = "WRITE_CAPABLE"; 
	public static final String  ACTION_YES = "YES"; 
	public static final String  ACTION_NO = "NO"; 
	
	/**
	 * Get the registered file types
	 * @param filter It is possible to specify a filter to retrieve only FileTypes
	 * which complains a constraint:
	 * String filter = StringConstructor.Construct(new String[] { "(",
		GvSigConstants.FILETYPE_DESC, "=", "SHP", ")" });
	 * pass null as the filter parameter to retrieve all the FileTypes registered	
	 * @param bc The bundle context
	 * @return
	 * @throws GvSigServiceNotFoundException
	 */
	public static IFileType[] getRegisteredFileTypes(String filter, BundleContext bc) throws GvSigServiceNotFoundException {

		try {
			
			IFileType[] res;

			String aux = IFileType.class.getName();
			ServiceReference funcReferences[] = bc.getServiceReferences(aux, filter);
			if (funcReferences != null) {
				ShowMessage.Show(
						"(gvSIG Mobile File type Resolutor) FileType found!",
						true);
				
				final int length = funcReferences.length;
				res = new IFileType[length];
				
				for (int i = 0; i<length; i++) {
					res[i] = (IFileType) bc
					.getService(funcReferences[i]);
				}

				return res;
			}
			throw new GvSigServiceNotFoundException("IFileType");

		} catch (Exception e) {
			e.printStackTrace();			
			throw new GvSigServiceNotFoundException("IFileType");
		}
	}

}
