package org.gvsig.mobile.core.concepts;

import java.util.Hashtable;

import org.gvsig.mobile.core.auxfunctions.FunctionalityResolutor;
import org.gvsig.mobile.core.constants.GvSigConstants;
import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.gvsig.mobile.core.extensions.interfaces.IFileProviderFunctionality;
import org.gvsig.mobile.core.extensions.interfaces.IFileType;
import org.osgi.framework.BundleContext;

public class DefaultFileType implements IFileType {

	private Hashtable props = new Hashtable();
	private BundleContext context;
	private IFileProviderFunctionality f;

	public DefaultFileType(String filetype, String descr, String funcID,
			BundleContext context) {
		this.props.put(GvSigConstants.FILETYPE_ID, filetype);
		this.props.put(GvSigConstants.FILETYPE_DESC, descr);
		this.props.put(GvSigConstants.FILETYPE_FUNCID, funcID);
		this.context = context;
	}

	public String getFileType() {
		return (String) this.props.get(GvSigConstants.FILETYPE_ID);
	}

	public String getFileTypeDescription() {
		return (String) this.props.get(GvSigConstants.FILETYPE_DESC);
	}

	public Hashtable getProps() {
		return props;
	}

	public void setFileType(String fileType) {
		this.props.put(GvSigConstants.FILETYPE_ID, fileType);
	}

	public void setFileTypeDescription(String fileTypeDescription) {
		this.props.put(GvSigConstants.FILETYPE_DESC, fileTypeDescription);

	}

	public IFileProviderFunctionality getFunctionality() throws GvSigServiceNotFoundException {
		if (this.f == null) {
			f = (IFileProviderFunctionality)FunctionalityResolutor.solve(this.getFunctionalityID(), null,
					null, null, null, null, null, this.getBundleContext());
		}
		return f;
	}

	public String getFunctionalityID() {
		return this.props.get(GvSigConstants.FILETYPE_FUNCID).toString();
	}

	public void setFunctionalityID(String funcID) {
		this.props.put(GvSigConstants.FILETYPE_FUNCID, funcID);
	}

	public BundleContext getBundleContext() {
		return context;
	}
}
