package org.gvsig.mobile.core.concepts;

import java.util.ArrayList;

import org.gvsig.mobile.core.auxfunctions.ShowMessage;
import org.gvsig.mobile.core.extensions.interfaces.IExtensionStoreProvider;
import org.gvsig.mobile.core.extensions.interfaces.IFileType;
import org.osgi.framework.BundleContext;

public class ExtensionStoreProvider extends Extension implements
		IExtensionStoreProvider {

	private ArrayList fileTypes = new ArrayList();
	
	public ExtensionStoreProvider(String ID, BundleContext context) {
		super(ID, context);
	}

	public boolean addFileType(IFileType type) {
		try {
			this.fileTypes.add(type);
			ShowMessage.Show("The file type has been properly added", true);
			return true;
		} catch (Exception e) {
			ShowMessage.Show("An error occurred adding file type", true);
			return false;
		}
	}

	public boolean removeFileType(IFileType type) {
		try {
			boolean res = this.fileTypes.remove(type);
			if (res) {
				ShowMessage.Show("The file type has been properly removed",
						true);
				return true;
			}
			ShowMessage.Show("The file type is not present", true);
			return false;
		} catch (Exception e) {
			ShowMessage.Show("An error occurred removing file type", true);
			return false;
		}
	}

	public boolean registerAll() {
		boolean ret = super.registerAll();

		if (ret == false)
			return ret;

		for (int i = 0; i < fileTypes.size(); i++) {
			services.add(bc.registerService(IFileType.class.getName(),
					(IFileType) fileTypes.get(i), ((IFileType)fileTypes.get(i)).getProps()));
		}

		return true;
	}
}
