package org.gvsig.mobile.core.interfaces;


/**
 * This Interface provides the methods that must implement every Mouse Event of GvSIG Mobile
 * @author ProS
 */
public interface IGvSigMouseEvent {
	/**
	 * 
	 * @return The X coordinate of the mouse pointer relatively the desktop parent component.
	 */
	public int getAbsX(); 
	
	/**
	 * 
	 * @return The Y coordinate of the mouse pointer relatively the desktop parent component.
	 */
	public int getAbsY(); 
    
	/**
	 * 
	 * @return The number of consecutive mouse clicks
	 */
	public int getClickCount(); 
    
    /**
     * 
     * @return The mask.
     */
    public int getMask(); 
    
    /**
     * 
     * @return The X coordinate of the mouse pointer relatively the source component.
     */
    public int getX(); 
    
    /**
     * 
     * @return The Y coordinate of the mouse pointer relatively the source component.
     */
    public int getY(); 
    
    /**
     * 
     * @return The event id.
     */
	public int getID();
    
    /**
     * Sets the absolute X coordinate
     * @param AbsX The X coordinate of the mouse pointer relatively the desktop parent component.
     */
    public void setAbsX(int AbsX); 
	
    /**
     * Sets the absolute Y coordinate
     * @param AbsY The X coordinate of the mouse pointer relatively the desktop parent component.
     */
    public void setAbsY(int AbsY); 
    
    /**
     * Sets the number of consecutive mouse clicks
     * @param ClickCount The number of consecutive mouse clicks
     */
    public void setClickCount(int ClickCount); 
    
    /**
     * Sets the mask of the event
     * @param Mask the Mask of the event
     */
    public void setMask(int Mask); 
    
    /**
     * Sets the relative X coordinate
     * @param X The X coordinate of the mouse pointer relatively the source component.
     */
    public void setX(int X); 
    
    /**
     * Sets the relative Y coordinate
     * @param Y The Y coordinate of the mouse pointer relatively the source component.
     */
    public void setY(int Y); 
    
    /**
     * 
     * @param ID The ID of the event
     */
    public void setID(int ID);
    


}
