package org.gvsig.mobile.core.interfaces;

import org.osgi.framework.BundleContext;
import org.osgi.service.wireadmin.Wire;
/**
 * This Interface provides the methods that must implement every Mouse Event Provider plugin of GvSIG Mobile</br>
 * @author ProS
 */
public interface IMouseEventProvider {
	
	/**
	 * Sets the OSGi bundle context of the Mouse Event Provider
	 * @param context The bundle context
	 */
	public void setBundleContext(BundleContext context);
	
	/**
	 * 
	 * @return The bundle context of the mouse provider
	 */
	public BundleContext getBundlecontext();
	
	/**
	 * The Producer Service PID of this Mouse Event Provider
	 * @param pid The ID
	 */
	public void setPID(String pid);
	
	/**
	 * 
	 * @return The Producer Service PID of this Mouse Event Provider
	 */
	public String getPID();
	
	/**
	 * 
	 * @return The wires of which is producer
	 */
	public Wire[] getWires();

}
