/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package org.gvsig.mobile.extension.base.forms.model;

import org.gvsig.fmap.dal.feature.FeatureReference;
import org.gvsig.fmap.dal.feature.impl.DefaultFeatureReference;


/**
 * This class is temporary, it represents a feature
 * and should be deleted when porting this code to
 * gvSIG 2.0
 * 
 * @author jcarras
 *
 */
public class FeatureTemp implements Cloneable{
	
	// private int rowIndex;
	private DefaultFeatureReference featRef = null;
	
	private Object[] values;
	private String[] fieldNames;
	private int[] fieldTypes;
	private String geometryFieldName = "GEOMETRY";
	
	public String getGeometryFieldName() {
		return geometryFieldName;
	}
	public void setGeometryFieldName(String n) {
		this.geometryFieldName = n;
	}
	
	private FeatureTemp() {
		
	}
	
	/**
	 * Forces assignment of geometry field name
	 * @param geo_fld_name
	 */
	public FeatureTemp(String geo_fld_name) {
		setGeometryFieldName(geo_fld_name);
	}

	/**
	 * 
	 * @return an ordered array with all the values of the attributes
	 */
	public Object[] getValues() {
		return values;
	}
	public void setValues(Object[] values) {
		this.values = values;
	}
	
	/**
	 *  
	 * @return an ordered array containing all the attribute names
	 */
	public String[] getFieldNames() {
		return fieldNames;
	}
	public void setFieldNames(String[] fieldNames) {
		this.fieldNames = fieldNames;
	}
	
	/**
	 * Returns  an ordered array with all the types of the attributes
	 * the attribute types are those defined in ValueFactory 
	 * 
	 * @see com#hardcode#gdbms#engine#values#ValueFactory
	 * 
	 * @return an ordered array with all the types of the attributes
	 * 
	 */
	public int[] getFieldTypes() {
		return fieldTypes;
	}
	public void setFieldTypes(int[] fieldTypes) {
		this.fieldTypes = fieldTypes;
	}
	
	public Object clone(){
		FeatureTemp fea = new FeatureTemp(getGeometryFieldName());
		fea.setFeatureReference(getFeatureReference());
		fea.setFieldNames((String[])fieldNames.clone());
		fea.setFieldTypes((int[])fieldTypes.clone());
		fea.setValues((Object[]) values.clone());
		return fea;
	}
	/**
	 * This is the row identifier, currently is always the row number
	 * @return
	 */
	public FeatureReference getFeatureReference() {
		return featRef;
	}
	
	public void setFeatureReference(FeatureReference fr) {
		featRef = (DefaultFeatureReference) fr;
	}
	
}
