/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package org.gvsig.mobile.extension.base.forms.view;

import java.awt.Rectangle;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.gvsig.mobile.extension.base.forms.model.FeatureTemp;
import org.gvsig.mobile.ui.awt.ImageUtils;
import org.osgi.framework.BundleContext;


/**
 * This Form is constructed using a Thinlet XML mixed with the gvSIG template
 * It's aimed to be constructed by the developer and shown and hided by
 * {@link AlphanumericalData}
 * 
 * @author jcarras
 *
 */
public class CustomForm extends GenericForm{

	public static final String PROPERTY_KEY_USES_CUSTOM_FORM = "PROPERTY_KEY_USES_CUSTOM_FORM";
	public static final String PROPERTY_KEY_CUSTOM_FORM_PATH = "PROPERTY_KEY_CUSTOM_FORM_PATH";
	
	String formPath;
	

	/**
	 * 
	 * @param parent Parent Frame
	 * @param formPath Absolute path to the Thinlet XML file defining the form
	 * @throws IllegalArgumentException
	 * @throws IOException
	 */
	public CustomForm(String formPath, BundleContext bc, Rectangle bounds) throws IllegalArgumentException, IOException{
		super(bc, bounds);
		this.formPath=formPath;
		try {
			frm.add(frm.parse(getMixedTemplate()));
			// add(frm, BorderLayout.CENTER);
			// addWindowListener(this);
			frm.setIcon(
					frm.find("btnsave"),
					"icon",
					ImageUtils.getResourceImage(bc.getBundle(), "ok_2_new"));
			frm.setIcon(
					frm.find("btncancel"),
					"icon",
					ImageUtils.getResourceImage(bc.getBundle(), "cancel_2_new"));
			//pack();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			this.close();
			throw e;
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			this.close();
			throw e1;
		}
	}
	
	/**
	 * This method it's called by getMixedTemplate() and adds the custom form
	 * lines to the StringBuffer buff
	 */
	protected void addCustomFormLines(StringBuffer buff){
		try{
			BufferedReader tin = new BufferedReader(new FileReader(formPath));
			String line;
			while ( (line=tin.readLine()) != null ) {
				buff.append(line);
            }
		} catch (FileNotFoundException e){
			e.printStackTrace();
		} catch (IOException e1){
			e1.printStackTrace();
		}
	}

	/**
	 * Binds the components of the form
	 * with the feature attributes
	 */
	public void setFeature(FeatureTemp feature) {
		//Fills all the binded components with the values in the feature
		originalFeature=feature;
		fillFields();
		
	}
}
