package org.gvsig.mobile.extension.base.layer.functionality;

import org.gvsig.i18n.Messages;
import org.gvsig.mobile.app.MainFrame;
import org.gvsig.mobile.core.auxfunctions.FileTypeResolutor;
import org.gvsig.mobile.core.auxfunctions.StringConstructor;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.constants.GvSigConstants;
import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.gvsig.mobile.core.extensions.interfaces.IFileProviderFunctionality;
import org.gvsig.mobile.core.extensions.interfaces.IFileType;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.ui.lw.FileChooserDialog;
import org.gvsig.mobile.ui.lw.FileChooserListener;
import org.gvsig.mobile.ui.lw.LongTaskDialog;
import org.gvsig.mobile.ui.lw.MessageBox;
import org.osgi.framework.ServiceReference;
import org.zaval.lw.event.LwActionListener;

public class AddFileLayerFunc extends Functionality implements
		FileChooserListener, LwActionListener {

	public AddFileLayerFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			
			String filter = "(" +
			FileTypeResolutor.ACTION_READ_PARAMETER_KEY +
			"=" + FileTypeResolutor.ACTION_YES + ")"; 

			IFileType[] fileTypes = FileTypeResolutor.getRegisteredFileTypes(filter, bc);

			String[][] types = new String[fileTypes.length][2];
			// types[0] = UIConstants.FILTER_ALL;

			IFileType f;
			for (int i = 0; i < fileTypes.length; i++) {
				f = fileTypes[i];
				if (f != null) {
					types[i][0] = f.getFileTypeDescription();
					types[i][1] = f.getFileType();
				}
			}

			FileChooserDialog fc = new FileChooserDialog(
					this, null, types, FileChooserDialog.DIALOG_TYPE_SELECT);
			fc.setTitle(Messages.getText("Choose_layer_data_file"));
			fc.showDialog();

			super.stop();
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			MessageBox.showDialog(true, bc, Messages.getText("No_readers_found"),
					this, MessageBox.MESSAGE_TYPE_ERROR,
					MessageBox.MESSAGE_ONLY_CANCEL);
			return false;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
	}

	public void fileSelected(String path) {
		// TODO Auto-generated method stub

		int lastPoint = path.lastIndexOf(".");
		String extension = path.substring(lastPoint + 1).toLowerCase();

		String filter = StringConstructor.Construct(new String[] { "(",
				GvSigConstants.FILETYPE_ID, "=", extension, ")" });

		IFileType[] fileTypes;
		try {
			fileTypes = FileTypeResolutor.getRegisteredFileTypes(filter, bc);
			IFileProviderFunctionality f = fileTypes[0].getFunctionality();
			f.setFilePath(path);
			
			
			IGvSigContext gvc = (IGvSigContext)bc.getService(gvSigMobileRef);
			MainFrame mfr = (MainFrame) gvc.getMainFrame();
			
			new LongTaskDialog(
					"Add layer task", f, mfr.getWidth(), LongTaskDialog.START_TASK_WITH_EXECUTE, false);
			

			// f.execute(this.gvSigMobileRef);
		} catch (GvSigServiceNotFoundException e) {
			// TODO Mostrar mensaje de error
			e.printStackTrace();
		}
	}

	public void actionPerformed(Object arg0, Object arg1) {
	}
	



}
