package org.gvsig.mobile.extension.base.layer.functionality;

import java.util.ArrayList;

import org.gvsig.fmap.mapcontext.layers.FLayer;
import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.i18n.Messages;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.extension.base.layer.dialog.ExportLayerDialog;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.gvsig.mobile.ui.lw.MessageBox;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ExportLayerFunc extends Functionality {

	private static Logger logger = LoggerFactory.getLogger(ExportLayerFunc.class);
	
	private IGvSigContext gvc = null;
	
	public ExportLayerFunc() {
		super();
	}
	
	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			super.stop();
			gvc = (IGvSigContext)bc.getService(gvSIGMobileRef);
			MapControl mc = (MapControl) gvc.getMapControl();
			
			ArrayList layers = mc.getLayersForReading();
			ArrayList vlayers = new ArrayList();
			int sz = layers.size();
			for (int i=0; i<sz; i++) {
				FLayer lyr = (FLayer) layers.get(i);
				if (lyr instanceof FLyrVect) vlayers.add(lyr);
			}
			
			if (vlayers.size() == 0) {
				logger.warn("No vector layers in TOC");
				MessageBox.showDialog(false, bc,
						Messages.getText("no_vector_layers_found"),
						null, MessageBox.MESSAGE_TYPE_INFO, MessageBox.MESSAGE_ONLY_OK);
				return true;
			}

			ExportLayerDialog e = new ExportLayerDialog(this.getBundleContext(), vlayers);
			e.showDialog();
			return true;
		} catch (Exception e) {
			logger.error("While opening export dialog: " + e.getMessage());
			return false;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}
}
