/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
/************************************************
 *												*
 *   Modfied By:								*
 *   Prodevelop Integracin de Tecnologas SL	*
 *   Conde Salvatierra de lava , 34-10			*
 *   46004 Valencia								*
 *   Spain										*
 *												*
 *   +34 963 510 612							*
 *   +34 963 510 968							*
 *   gis@prodevelop.es							*
 *   http://www.prodevelop.es					*
 *												*
 *   gvSIG Mobile Team 2006 					*
 *  											*	 
 ************************************************/

package org.gvsig.mobile.extension.base.layer.raster;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.IOException;

import org.gvsig.fmap.mapcontext.ViewPort;
import org.gvsig.tools.persistence.Persistent;


public interface RasterDriver extends Persistent {
	
	public final static int ONE_PIXEL_IMAGE_ERROR = -100;
	public final static int ONE_PIXEL_NO_DATA = -101;
	
   /**
    * Define los tipos de fichero que puede leer el driver. Si devuelve true,
    * el fichero est aceptado (es de los que el driver puede leer), si
    * devuelve false es porque no lo puede leer.
    */
	public boolean fileAccepted(File fName);
	
	public String getName();
	
	public void open(File f) throws IOException;

	public void initialize() throws IOException;

	public void close() throws IOException;
	
	public String getFilePath();

   /**
    * Obtiene la extensin en coordenadas del mundo real que ocupa este raster 
    */
	public Rectangle2D getFullExtent();
   /**
    * Obtiene el nmero de bandas del raster 
    */
	public int getNumBands();
	
	public int getTransparency();
	
	public void setTransparency(int trans);
	public void draw(Graphics2D g, ViewPort viewPort);
			

	public int getRasterDataType();
	public Object getData(int x, int y, int band);
	public int[] getPixel(double wcx, double wcy);
}