package org.gvsig.mobile.extension.base.navigation.functionality;

import java.awt.Point;
import java.awt.geom.AffineTransform;
import java.awt.geom.NoninvertibleTransformException;
import java.awt.geom.Point2D;
import java.util.Timer;

import org.gvsig.fmap.geom.primitive.Envelope;
import org.gvsig.fmap.geom.primitive.impl.Envelope2D;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.zaval.lw.event.LwMouseEvent;

public class PanFunc extends Functionality {
	
	private MapControl mapCtrl;
	private Point startPoint = null;
	private Timer refreshTimer;
	private PanRefreshTimerTask refreshTask;
	
	private static final int REFRESH_MILISECONDS = 100;
	
	public PanFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			//TODO: Implement this			
//			super.stop();
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		int id = event.getID();		
		int dif_x = 0;
		int dif_y = 0;
		
		if (this.mapCtrl == null) {
			final BundleContext bc = getBundleContext();
			IGvSigContext gv = (IGvSigContext)bc.getService(gvSigMobileRef);
			this.mapCtrl = (MapControl)gv.getMapControl();
		}

		switch (id) {
		
		case LwMouseEvent.MOUSE_DRAGGED:
			Point2D tmpp = null;
//			
//			//Esto tarda 2 ms
//			grf.removeGraphics(DRAG_TOOL_RECT);			
//			
			try {
				tmpp = getMapPoint(event.getX(), event.getY(), mapCtrl.getViewPort()
						.getAffineTransform());
			} catch (Throwable th) {
				th.printStackTrace();
			}
			
//			refreshTask.p = tmpp;
//			mapCtrl.draw(tmpp);
			if (startPoint != null) {				
				dif_x = event.getX() - startPoint.x;
				dif_y = event.getY() - startPoint.y;
				
//				logger.debug("MOUSE_DRAGGED - dif_x = " + dif_x + ", dif_y = " + dif_y);
				
				refreshTask.setOffSetX(dif_x);
				refreshTask.setOffSetY(dif_y);
			}
			break;
			
		case LwMouseEvent.MOUSE_PRESSED:		
			
			if (refreshTimer != null) return;
			mapCtrl.panMode = true;			
			startPoint = new Point(event.getX(), event.getY());
			// frozenImage = mapCtrl.getCurrentImage();
			// int w = frozenImage.getWidth(null);
			// int h = frozenImage.getHeight(null);			

//			mapCtrl.setToolsImageForPanDrag(true);
			refreshTask = new PanRefreshTimerTask(mapCtrl);
			refreshTask.setOffSetX(0);
			refreshTask.setOffSetY(0);
			refreshTimer = new Timer();
			refreshTimer.schedule(refreshTask, 0, REFRESH_MILISECONDS);
			break;
		
		case LwMouseEvent.MOUSE_RELEASED:			
			try {
				refreshTimer.cancel();
			} catch (Exception e) {
				//ignore
			} finally {
				refreshTimer = null;
			}
			
			

			
//			mapCtrl.setToolsImageForPanDrag(false);

			if (startPoint == null) break;
			
			Envelope oldext = mapCtrl.getViewPort().getAdjustedEnvelope();
			if (oldext == null) {
				break;
			}
			
			// -------------------------- starts working
//			if (mapCtrl.isProcessing()) {
//				return;
//			} else {
//				mapCtrl.setProcessing(true);
//			}
			
			//mapCtrl.setOffsetAndRefresh(0, 0, false);
			
			dif_x = event.getX() - startPoint.x;
			dif_y = event.getY() - startPoint.y;
			startPoint = null;
			
			double scalex = mapCtrl.getViewPort().getAffineTransform().getScaleX();
			double scaley = mapCtrl.getViewPort().getAffineTransform().getScaleY();
			double difxgeo = dif_x / scalex;
			double difygeo = dif_y / scaley;

			
			Envelope2D newext = new Envelope2D(
					oldext.getLowerCorner().getX() - difxgeo,
					oldext.getLowerCorner().getY() - difygeo,
					oldext.getUpperCorner().getX() - difxgeo,
					oldext.getUpperCorner().getY() - difygeo);

			ZoomNextEnvelopeHistory.clearNextEnvelopes();
			mapCtrl.getViewPort().setEnvelope(newext);
						
			break;
			default:break;
		}
	}
	
	private Point2D getMapPoint(int x, int y, AffineTransform at) {

		Point2D screenp = new Point2D.Double(x, y);
		Point2D mapp = new Point2D.Double(0, 0);
		try {
			at.inverseTransform(screenp, mapp);
		} catch (NoninvertibleTransformException e) {
		}
		return mapp;
	}
}
