package org.gvsig.mobile.extension.base.navigation.functionality;

import java.awt.geom.Rectangle2D;

import org.gvsig.fmap.geom.primitive.Envelope;
import org.gvsig.fmap.geom.primitive.impl.Envelope2D;
import org.gvsig.fmap.geom.primitive.impl.Point2D;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.osgi.framework.ServiceReference;

public class ZoomInFunc extends Functionality {
	
	private MapControl canvas;
	
	public ZoomInFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			if (this.canvas == null) {
				IGvSigContext gv = (IGvSigContext)bc.getService(gvSIGMobileRef);
				this.canvas = (MapControl)gv.getMapControl();
			}
			Envelope envelope = canvas.getViewPort().getAdjustedEnvelope();
			Rectangle2D newExtent = null;
			// Esto comprueba que el extent no es de anchura o altura = "0"
			// si lo es lo redimensiona.
			if (envelope != null) {
				if ((envelope.getMaximum(0) - envelope.getMinimum(0) == 0)
						|| (envelope.getMaximum(1) - envelope.getMinimum(1) == 0)) {
					newExtent = new Rectangle2D.Double(envelope.getMinimum(0) - 0.1, 
							envelope.getMinimum(1) - 0.1, envelope.getMaximum(0) - envelope.getMinimum(0)
							+ 0.2, envelope.getMaximum(1) - envelope.getMinimum(1) + 0.2);
				} else {
					newExtent = new Rectangle2D.Double(envelope.getMinimum(0), 
							envelope.getMinimum(1), Math.abs(envelope.getMaximum(0)
							- envelope.getMinimum(0)), Math.abs(envelope.getMaximum(1)
							- envelope.getMinimum(1)));
				}
			}
			//Set the new Rectangle size
			double newHeight = newExtent.getHeight()*0.5;
			double newWidth = newExtent.getWidth()*0.5;
			//calculates lowerCorner and upperCorner from the center subtracting and adding the half of width/height 
			Point2D min = new Point2D(newExtent.getCenterX() - newWidth * 0.5, newExtent.getCenterY() - newHeight * 0.5);
			Point2D max = new Point2D(newExtent.getCenterX() + newWidth * 0.5, newExtent.getCenterY() + newHeight * 0.5);
			Envelope2D newext = new Envelope2D(min, max);
			ZoomNextEnvelopeHistory.clearNextEnvelopes();
			canvas.getViewPort().setEnvelope(newext);		
			canvas.repaint();
			super.stop();
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}
	
	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

}
