package org.gvsig.mobile.extension.base.project.functionality;

import java.io.File;
import java.io.FileOutputStream;

import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.project.Project;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.gvsig.mobile.ui.lw.FileChooserDialog;
import org.gvsig.mobile.ui.lw.FileChooserListener;
import org.gvsig.mobile.ui.lw.UIConstants;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class ProjectSaveAsFunc extends Functionality implements FileChooserListener {
	
	final static private Logger logger =
		LoggerFactory.getLogger(ProjectSaveFunc.class);

	private MapControl canvas;
	
	public ProjectSaveAsFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {

			if (this.canvas == null) {
				IGvSigContext gv = (IGvSigContext)bc.getService(gvSIGMobileRef);
				this.canvas = (MapControl)gv.getMapControl();
			}
			
			FileChooserDialog f = new FileChooserDialog(this, null, new String[][]{UIConstants.FILTER_GVM}, FileChooserDialog.DIALOG_TYPE_CREATE_NEW);		
			f.showDialog();
			super.stop();
			return true;
		} catch (Exception e) {
			logger.error("While choosing file: " + e.getMessage());
			return false;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

	public void fileSelected(String path) {
		
		Project pr = canvas.getProject(); // 
		PersistenceManager pma = ToolsLocator.getPersistenceManager();
		
		try {
			File fi = new File(path);
			pr.setProjectFile(fi);
			PersistentState psta = pma.getState(pr); 
			FileOutputStream fos = new FileOutputStream(fi);
			pma.saveState(psta, fos);
			fos.close();
		} catch (Exception ex) {
			logger.error("While storing project: " + ex.getMessage());
		}
	}

}
