package org.gvsig.mobile.extension.base.util;

import java.awt.Graphics;
import java.util.ArrayList;

import org.zaval.lw.LwTextField;
import org.zaval.lw.event.LwKeyEvent;
import org.zaval.lw.event.LwKeyListener;

public class LwKeyEventFwTextField extends LwTextField {
	
	private ArrayList keyListeners = new ArrayList();
	
	public int addKeyListener(LwKeyListener kl) {
		if (!keyListeners.contains(kl)) {
			keyListeners.add(kl);
		}
		return keyListeners.size();
	}
	
	public int removeKeyListener(LwKeyListener kl) {
		if (keyListeners.contains(kl)) {
			keyListeners.remove(kl);
		}
		return keyListeners.size();
	}
	
	public void keyPressed(LwKeyEvent ke) {
		super.keyPressed(ke);
		notifyKP(ke);
	}
	
	public void keyReleased(LwKeyEvent ke) {
		super.keyReleased(ke);
		notifyKR(ke);
	}
	
	public void keyTyped(LwKeyEvent ke) {
		super.keyTyped(ke);
		notifyKT(ke);
	}
	
	public void notifyKP(LwKeyEvent kev) {
		int len = keyListeners.size();
		LwKeyListener item = null;
		for (int i=0; i<len; i++) {
			item = (LwKeyListener) keyListeners.get(i);
			item.keyPressed(kev);
		}
	}
	
	public void notifyKR(LwKeyEvent kev) {
		int len = keyListeners.size();
		LwKeyListener item = null;
		for (int i=0; i<len; i++) {
			item = (LwKeyListener) keyListeners.get(i);
			item.keyReleased(kev);
		}
	}
	
	public void notifyKT(LwKeyEvent kev) {
		int len = keyListeners.size();
		LwKeyListener item = null;
		for (int i=0; i<len; i++) {
			item = (LwKeyListener) keyListeners.get(i);
			item.keyTyped(kev);
		}
	}
	
	public void paint(Graphics g) {

	}
	
	
	

}
