package org.gvsig.mobile.extension.editing.functionality;

import java.awt.geom.Point2D;

import org.gvsig.fmap.dal.exception.ReadException;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.primitive.Circle;
import org.gvsig.fmap.geom.primitive.Point;
import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.mobile.core.constants.GvSigMouseEventType;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;

/**
 * @author Vicente Caballero Navarro
 */
public class AddCircleFunc extends EditingFunctionality implements InsertablePoint{
    private Point2D firstPoint = null;
    
    public AddCircleFunc() {
        super();
    }
    
    public void configure() {
        // TODO Auto-generated method stub
        
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
        int type = event.getID();
        
        if (type == GvSigMouseEventType.MOUSE_PRESSED) {
            Point2D point = getHandlerAdjustedPoint();
            addPoint(point);
        }
    }
    
    protected Circle createCircle(Point p1, Point p2) {
        Circle circle = null;
        try {
            circle = (Circle) geomManager.create(Geometry.TYPES.CIRCLE,
                    Geometry.SUBTYPES.GEOM2D);
            circle.setPoints(p1, p2);
            circle.getGeneralPath().closePath();
        } catch (org.gvsig.fmap.geom.exception.CreateGeometryException e) {
            e.printStackTrace();
        }
        return circle;
    }
    
    public boolean isApplicable() {
        FLyrVect lv = getEditingLayer();
        try {
            int type = lv.getShapeType();
            if (
            		type == Geometry.TYPES.CURVE ||
            		type == Geometry.TYPES.SURFACE ||
            		type == Geometry.TYPES.MULTICURVE ||
            		type == Geometry.TYPES.MULTISURFACE ||
            		type == Geometry.TYPES.GEOMETRY) {
                return true;
            }
        } catch (ReadException e) {
            e.printStackTrace();
        }
        return false;
    }

	public void addPoint(Point2D point) {
		 if (firstPoint == null) {
             firstPoint = point;
             drawGeometry(createPoint(firstPoint.getX(), firstPoint.getY()));
         } else {
             Point2D secondPoint = point;
             Geometry circle = createCircle(createPoint(firstPoint.getX(), firstPoint
                     .getY()), createPoint(secondPoint.getX(), secondPoint
                     .getY()));
             insertGeometry(circle);
             firstPoint = null;
         }
	}
}
