package org.gvsig.mobile.extension.editing.functionality;

import java.awt.geom.Point2D;
import java.util.ArrayList;

import org.gvsig.fmap.dal.exception.ReadException;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.exception.CreateGeometryException;
import org.gvsig.fmap.geom.primitive.GeneralPathX;
import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.mobile.core.constants.GvSigMouseEventType;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.tools.locator.LocatorException;

/**
 * @author Vicente Caballero Navarro
 */
public class AddPolygonFunc extends AddPolilineFunc {
    public AddPolygonFunc() {
        super();
    }
    
    public void configure() {
        // TODO Auto-generated method stub
        
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
        int type = event.getID();
        
        if (type == GvSigMouseEventType.MOUSE_PRESSED) {
        	Point2D point=getHandlerAdjustedPoint();
        	addPoint(point);
        }
    }
    
    protected GeneralPathX createGPXPolygon(ArrayList points) {
        GeneralPathX gpx = new GeneralPathX();
        for (int i = 0; i < points.size(); i++) {
            Point2D p = (Point2D) points.get(i);
            if (i == 0)
                gpx.moveTo(p.getX(), p.getY());
            else
                gpx.lineTo(p.getX(), p.getY());
        }
        Point2D p=(Point2D)points.get(0);
        gpx.lineTo(p.getX(), p.getY());
        gpx.closePath();
        return gpx;
    }
    
    public boolean isApplicable() {
        FLyrVect lv = getEditingLayer();
        try {
            int type = lv.getShapeType();
            if (
            		type == Geometry.TYPES.CURVE ||
            		type == Geometry.TYPES.SURFACE ||
            		type == Geometry.TYPES.MULTICURVE ||
            		type == Geometry.TYPES.MULTISURFACE ||
            		type == Geometry.TYPES.GEOMETRY) {
                return true;
            }
        } catch (ReadException e) {
            e.printStackTrace();
        }
        return false;
    }
    
    public void addPoint(Point2D point){
    	points.add(point);
        GeneralPathX gpx = createGPXPolygon(points);
        try {
            geom = geomManager.createSurface(gpx, Geometry.SUBTYPES.GEOM2D);
            drawGeometry(geom);
        } catch (LocatorException e) {
            e.printStackTrace();
        } catch (CreateGeometryException e) {
            e.printStackTrace();
        }
    }
}
