package org.gvsig.mobile.extension.editing.functionality;

import java.awt.geom.Point2D;

import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.tools.dispose.DisposableIterator; 
import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.dal.feature.FeatureSelection;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.util.UtilFunctions;
import org.gvsig.mobile.core.constants.GvSigMouseEventType;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;

/**
 * @author Vicente Caballero Navarro
 */
public class ModifyCopyFunc extends SelectionFunc implements InsertablePoint{
    private Point2D firstPoint;
    private Point2D lastPoint;
    
    public void configure() {
        // TODO Auto-generated method stub
        
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
        int type = event.getID();
        if (type == GvSigMouseEventType.MOUSE_PRESSED) {
    		Point2D point = getHandlerAdjustedPoint();
    		addPoint(point);
        }
    }

    public void addPoint(Point2D point) {
    	try{
    		FeatureStore featureStore=getEditingLayer().getFeatureStore();
    		FeatureSelection selection=featureStore.getFeatureSelection();
    		if(selection.isEmpty()){
    			selectWithPoint(point);
    		}else{
    			if (firstPoint==null){
    				firstPoint = point;
    			} else {
    				lastPoint = point;
    				featureStore.beginEditingGroup(getName());
    				FeatureSelection newSelection = featureStore
    				.createFeatureSelection();
    				DisposableIterator iterator = null;
    				try{
    					iterator = selection.iterator();
    					while (iterator.hasNext()) {
    						Feature feature = (Feature) iterator.next();
    						// Movemos la geometra
    						Geometry geometry=(feature.getDefaultGeometry()).cloneGeometry();
    						UtilFunctions.moveGeom(geometry, lastPoint.getX() -
    								firstPoint.getX(), lastPoint.getY() - firstPoint.getY());
    						newSelection.select(insertGeometry(geometry, feature));
    					}
    					featureStore.setSelection(newSelection);
    				} catch (DataException e) {
    					firstPoint=null;
    					featureStore.endEditingGroup();
    					throw e;
    				} finally{
    					if (iterator != null){
    						iterator.dispose();
    					}
    				}
    			}
    		}
    	} catch (DataException e) {
    		e.printStackTrace();
    	}
    }
}
