package org.gvsig.mobile.extension.editing.functionality;

import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.exception.ReadException;
import org.gvsig.tools.dispose.DisposableIterator; 
import org.gvsig.fmap.dal.feature.EditableFeature;
import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.dal.feature.FeatureSet;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.exception.CreateGeometryException;
import org.gvsig.fmap.geom.operation.GeometryOperationException;
import org.gvsig.fmap.geom.operation.GeometryOperationNotSupportedException;
import org.gvsig.fmap.geom.operation.tojts.ToJTS;
import org.gvsig.fmap.geom.util.Converter;
import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.osgi.framework.ServiceReference;

/**
 * @author Vicente Caballero Navarro
 */
public class ModifyJoinFunc extends SelectionVertexFunc{
    
	public boolean execution(ServiceReference gvSIGMobileRef) {
        boolean execute = super.execution(gvSIGMobileRef);
        join();
        super.stop();
        return execute;
    }
    public void configure() {
        // TODO Auto-generated method stub
        
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
    }
    
    
    public void join() {
    	FeatureStore featureStore = null;
		featureStore = getEditingLayer().getFeatureStore();
		DisposableIterator features = null;
		try {
		FeatureSet selection = (FeatureSet) featureStore.getSelection();
			featureStore.beginEditingGroup(getName());
    		com.vividsolutions.jts.geom.Geometry geomTotal=null;
    		features = selection.iterator();
    		boolean first=true;
    		Feature firstFeature=null;
    		while (features.hasNext()) {
				Feature feature = (Feature) features.next();
				if (first){
					firstFeature=feature;
					first=false;
				}
				org.gvsig.fmap.geom.Geometry geom = (feature
						.getDefaultGeometry()).cloneGeometry();
				featureStore.delete(feature);
				if (geomTotal==null){
    				geomTotal=(com.vividsolutions.jts.geom.Geometry)geom.invokeOperation(ToJTS.CODE, null);
    			}else{
    				com.vividsolutions.jts.geom.Geometry geomJTS=(com.vividsolutions.jts.geom.Geometry)geom.invokeOperation(ToJTS.CODE, null);
    				geomTotal=geomTotal.union(geomJTS);
    			}
			}

    		EditableFeature eFeature = featureStore.createNewFeature(firstFeature
					.getType(), firstFeature);
			eFeature.setGeometry(featureStore.getDefaultFeatureType()
					.getDefaultGeometryAttributeName(), Converter.jtsToGeometry(geomTotal));
			featureStore.insert(eFeature);
			repaintMap();
		} catch (DataException e) {
			e.printStackTrace();
		} catch (GeometryOperationNotSupportedException e) {
			e.printStackTrace();
		} catch (GeometryOperationException e) {
			e.printStackTrace();
		} catch (CreateGeometryException e) {
			e.printStackTrace();
		} finally {
			if (features != null) {
				features.dispose();
			}
		}
    }
    
    public boolean isApplicable() {
        FLyrVect lv = getEditingLayer();
        try {
            int type = lv.getShapeType();
            if (type == Geometry.TYPES.CURVE || type == Geometry.TYPES.SURFACE
                    || type == Geometry.TYPES.GEOMETRY) {
                return true;
            }
        } catch (ReadException e) {
            e.printStackTrace();
        }
        return false;
    }
 }
