package org.gvsig.mobile.extension.editing.functionality;

import java.awt.geom.Point2D;

import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.feature.FeatureQuery;
import org.gvsig.fmap.dal.feature.FeatureSet;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.exception.CreateGeometryException;
import org.gvsig.fmap.geom.primitive.GeneralPathX;
import org.gvsig.fmap.geom.primitive.Point;
import org.gvsig.mobile.core.constants.GvSigMouseEventType;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.graphicLayer.IntersectsGeometryEvaluatorCdc;
import org.gvsig.tools.evaluator.Evaluator;
;


/**
 * @author Vicente Caballero Navarro
 */
public class SelectionFunc extends EditingFunctionality implements SelectablePoint{
	 
	public SelectionFunc() {
		super();
		configure();
	}

    public void configure() {
        // TODO Auto-generated method stub
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
    	int type = event.getID();
    	if (type == GvSigMouseEventType.MOUSE_PRESSED) {
    		Point2D point = getMapPoint(event.getX(), event.getY());
    		selectWithPoint(point);
    	}
    }
    public void selectWithPoint(Point2D point){
    	try{
    		Point p=new org.gvsig.fmap.geom.primitive.impl.Point2D(point);
    		//		  Circle circle = (Circle)geomManager.create(Geometry.TYPES.CIRCLE, Geometry.SUBTYPES.GEOM2D);
    		//		  circle.setPoints(p, TOL);
    		GeneralPathX gpx=new GeneralPathX();
    		double middleTOL=getViewPort().toMapDistance(TOL)*0.5;
    		gpx.moveTo(p.getX()-middleTOL, p.getY()-middleTOL);
    		gpx.lineTo(p.getX()+middleTOL, p.getY()-middleTOL);
    		gpx.lineTo(p.getX()+middleTOL, p.getY()+middleTOL);
    		gpx.lineTo(p.getX()-middleTOL, p.getY()+middleTOL);
    		gpx.lineTo(p.getX()-middleTOL, p.getY()-middleTOL);
    		gpx.closePath();
    		Geometry geom=geomManager.createSurface(gpx,Geometry.SUBTYPES.GEOM2D);
    		FeatureStore featureStore=getEditingLayer().getFeatureStore();
    		FeatureQuery fq = featureStore.createFeatureQuery();
    		fq.setAttributeNames(new String[]{featureStore.getDefaultFeatureType().getDefaultGeometryAttributeName()});
    		Evaluator evaluator=new IntersectsGeometryEvaluatorCdc(geom, getViewPort().getProjection(), featureStore.getDefaultFeatureType(), featureStore.getDefaultFeatureType().getDefaultGeometryAttributeName());
    		fq.setFilter(evaluator);
    		FeatureSet set = featureStore.getFeatureSet(fq);
    		featureStore.getFeatureSelection().select(set);
    		drawHandlers(set);
    	} catch (DataException e) {
    		e.printStackTrace();
    	} catch (CreateGeometryException e) {
    		e.printStackTrace();
    	}
    }
}
