package org.gvsig.mobile.extension.editing.functionality;

import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.tools.undo.UndoException;
import org.osgi.framework.ServiceReference;

/**
 * @author Vicente Caballero Navarro
 */
public class UndoFunc extends EditingFunctionality {
    private FLyrVect lv = null;
    
    public boolean execution(ServiceReference gvRef) {
        boolean b= super.execution(gvRef);
        try {
        	getEditingLayer().getFeatureStore().undo();
        } catch (UndoException e) {
            e.printStackTrace();
        }
        stop();
        repaintMap();
        return b;
    }
    
    public void configure() {
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
    }
    
    public boolean isApplicable() {
        lv = getEditingLayer();
        if (lv != null) {
            return lv.getFeatureStore().canUndo();
        }
        return false;
    }
}
