package org.gvsig.mobile.extension.editing.gps.functionality;

import java.awt.geom.Point2D;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;
import org.gvsig.fmap.crs.CRSFactory;
import org.gvsig.location.LocationProvider;
import org.gvsig.location.QualifiedCoordinates;
import org.gvsig.mobile.app.MainFrame;
import org.gvsig.mobile.core.concepts.DefaultExclusiveTool;
import org.gvsig.mobile.core.extensions.interfaces.IFunctionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.extension.editing.functionality.EditingFunctionality;
import org.gvsig.mobile.extension.editing.functionality.SelectablePoint;
import org.gvsig.mobile.gps.GPSResolutor;
import org.osgi.framework.ServiceReference;

/**
 * @author Vicente Caballero Navarro
 */
public class SelectionGPSFunc extends EditingFunctionality {
    
	
	public boolean execution(ServiceReference gvRef) {
		boolean b= super.execution(gvRef);
		// If there's a location provider available, subscribe to location updates
		LocationProvider provider = GPSResolutor.getLocationProvider();
		
		if (provider!=null){
			QualifiedCoordinates qcoord=provider.getLastLocation().getQualifiedCoordinates();
			if (qcoord!=null){
				double latitude=qcoord.getLatitude();
				double longitude=qcoord.getLongitude();
//				double altitude=qcoord.getAltitude();
//				Debera devolver en que proyeccin est capturandose el punto desde el GPS, pero no est implementado 
//				y lo pondremos a pin en 4326.
//				String srs=qcoord.getSRS();
				String srs="EPSG:4326";
				IProjection gpsProj=CRSFactory.getCRS(srs);
				IProjection viewProj=getViewPort().getProjection();
				ICoordTrans ct=gpsProj.getCT(viewProj);
				//Hacer la reproyeccin adecuada desde el gps a la vista del punto a insertar
		
				Point2D pOriginal=new Point2D.Double(longitude, latitude);
				Point2D pDest=new Point2D.Double();
				pDest=ct.convert(pOriginal, pDest);
				
				IGvSigContext gv = (IGvSigContext)bc.getService(gvSigMobileRef);
				DefaultExclusiveTool det=(DefaultExclusiveTool)((MainFrame)gv.getMainFrame()).getActiveExclusiveTool();
				IFunctionality func=det.getFuncSolved();
				if (func!=null && func instanceof SelectablePoint )
					((SelectablePoint)func).selectWithPoint(pDest);
			}
		}
		stop();
//		repaintMap();
		return b;
		
	}
	

	
	
	
    public void configure() {
        // TODO Auto-generated method stub
        
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
        // TODO Auto-generated method stub
        
    }
    
}
