package org.gvsig.mobile.extension.gps;

import java.util.Properties;

import org.gvsig.mobile.core.concepts.BaseActivator;
import org.gvsig.mobile.gps.GPSConstants;
import org.gvsig.mobile.gps.GPSResolutor;
import org.osgi.framework.BundleContext;

public class Activator extends BaseActivator {

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context, context.getBundle());
		// Set default GPS preferences
		Properties gpsPrefs = new Properties();
		gpsPrefs.setProperty(GPSConstants.K_PROTOCOL, GPSConstants.V_PROTOCOL_NMEA);
		gpsPrefs.setProperty(GPSConstants.K_TARGET, GPSConstants.V_TARGET_COMM);
		// TODO --> Use a valid value for the current OS
		gpsPrefs.setProperty(GPSConstants.K_PORT_NAME, "COM1");
		gpsPrefs.setProperty(GPSConstants.K_BAUD_RATE, GPSConstants.V_BAUD_RATE_9600);
		gpsPrefs.setProperty(GPSConstants.K_AVG_POINT_SAMPLES, GPSConstants.V_AVG_POINT_DEFAULT);
		gpsPrefs.setProperty(GPSConstants.K_AVG_VERTEX_SAMPLES, GPSConstants.V_AVG_VERTEX_DEFAULT);
		gpsPrefs.setProperty(GPSConstants.K_AVG_FILTER_HACC, GPSConstants.V_OFF);
		gpsPrefs.setProperty(GPSConstants.K_AVG_FILTER_VACC, GPSConstants.V_OFF);
		gpsPrefs.setProperty(GPSConstants.K_AVG_FILTER_STDDEV, GPSConstants.V_OFF);
		gpsPrefs.setProperty(GPSConstants.K_TRK_TYPE, GPSConstants.V_TRK_TYPE_CAR);
		gpsPrefs.setProperty(GPSConstants.K_CURSOR_SHOW, GPSConstants.V_ON);
		gpsPrefs.setProperty(GPSConstants.K_CURSOR_RECENTER, GPSConstants.V_ON);
		// Register the properties object as service
		GPSResolutor.setGPSPrefs(gpsPrefs);
	}

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
	}

}
