/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana

 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibáñez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integración de Tecnologías SL
 *   Conde Salvatierra de Álava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robótica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */
package org.gvsig.mobile.extension.gps.dialog;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Date;

import org.gvsig.i18n.Messages;
import org.gvsig.location.Location;
import org.gvsig.location.LocationListener;
import org.gvsig.location.LocationProperties;
import org.gvsig.location.LocationProvider;
import org.gvsig.mobile.gps.GPSResolutor;
import org.gvsig.mobile.ui.awt.WindowManager;
import org.gvsig.mobile.ui.lw.DialogConstants;
import org.gvsig.mobile.ui.lw.FileChooserDialog;
import org.gvsig.mobile.ui.lw.FileChooserListener;
import org.gvsig.mobile.ui.lw.MessageBox;
import org.gvsig.mobile.ui.lw.OkCancelDialog;
import org.gvsig.mobile.ui.lw.UIConstants;
import org.osgi.framework.BundleContext;
import org.zaval.lw.LwBorderLayout;
import org.zaval.lw.LwButton;
import org.zaval.lw.LwFlowLayout;
import org.zaval.lw.LwNotebook;
import org.zaval.lw.LwPanel;
import org.zaval.lw.LwTextField;
import org.zaval.lw.LwTextRender;
import org.zaval.lw.LwScrollPan;

public class GPSActivityDialog extends OkCancelDialog implements FileChooserListener,
	LocationListener, PropertyChangeListener {
	
	private boolean debugging = false;
	private LwButton consolePlayButton;
	private LwButton consolePauseButton;
	private LwButton consoleStopButton;
	private LwButton consoleSaveButton;
	
	private LwTextField txtConsole;
	private LwTextField txtData1;
	private LwTextField txtData2;
	private LwTextField txtData3;
	
	//private int screenf = wToolkit.getDefaultToolkit().getScreenSize().width / 240;
	//private int CONSOLE_SIZE = 100 * screenf;
	
	
	private LwButton dataPropertiesButton;
	
	private String latitude;
	private String longitude;
	private String altitude;
	private String speed;
	private String hdop;
	private String vdop;
	private String hpe;
	private String vpe;
	private Date date;
	
	private GPSDataActivityDialog gData = null;
	private GPSSatelliteDialog gSatellite = null;
	
	public GPSActivityDialog(BundleContext bc) {
		super(false, bc);		
		this.getCancelButton().setVisible(false);
	}

	public void actionPerformed(Object src, Object arg1) {		
		
		if (src == consolePlayButton) {
			// Enable GPS debugging
			debugging = true;
			}
		if (src == consolePauseButton) {
			// Disable GPS debugging
			debugging = false;
			}
		if (src == consoleStopButton) {
			// Disable GPS debugging and empty console
			debugging = false;
			txtConsole.setText(""); //$NON-NLS-1$
			}
		if (src == this.consoleSaveButton) {
			final FileChooserDialog f =
				new FileChooserDialog(this, null, new String[][]{UIConstants.FILTER_ALL}, FileChooserDialog.DIALOG_TYPE_SELECT);
			f.setTitle(Messages.getText("GPSFilePrefsDialog.40"));		
			f.showDialog();		
			
			// Saves temporally debugging state
//			boolean debugState = debugging;
//			// If it was debugging, pauses GPS debugging
//			debugging = false;
//			// Saves the content of the console to the selected file
//			FileDialog fd = new FileDialog(parent, Messages.getText("GPSActivityDialog.11"), FileDialog.SAVE); //$NON-NLS-1$
//			fd.show();
//		       String fileName = fd.getFile();
//		       String directory = fd.getDirectory();
//
//		       if (fileName != null) {  // (otherwise, the user canceled the request)
//		            File file = new File(directory, fileName);
//			            try {
//				            // write the content of the textarea to an output stream
//							PrintWriter out = new PrintWriter(new FileWriter(file));
//							String content = txtConsole.getText();
//							out.print(content);
//				            out.close();
//
////							AcceptCancelDialog.informUser(
////		                            Messages.getText("GPSActivityDialog.12"),
////		                            Messages.getText("GPSActivityDialog.13") + " : " + fileName,
////		                            parent); //$NON-NLS-1$ //$NON-NLS-2$
//
//						} catch (IOException e) {
////							AcceptCancelDialog.informUser(
////		                            Messages.getText("GPSActivityDialog.14"),
////		                            Messages.getText("GPSActivityDialog.15") + " : " + fileName,
////		                            parent); //$NON-NLS-1$ //$NON-NLS-2$
//							e.printStackTrace();
//						}
//		       } else {
////					AcceptCancelDialog.informUser(
////                            Messages.getText("GPSActivityDialog.16"),
////                            Messages.getText("GPSActivityDialog.17"),
////                            parent); //$NON-NLS-1$ //$NON-NLS-2$
//		       }
//				// Restart debugging if it was debugging
//				debugging = debugState;
			} else if(src == dataPropertiesButton) {
				if(gData == null)
				{
					gData = new GPSDataActivityDialog(getBundleContext());
				}
				
				gData.showDialog();
			} else if (src == this.getOkButton()) {
			
				WindowManager.getInstance().closeActivePanel();
			}
	}

	public LwPanel buildMainPanel() {
		LwNotebook resp = new LwNotebook();	
		
		final LwTextRender tab1 = new LwTextRender("");
		tab1.setFont(DialogConstants.getDefaultFont());		
		tab1.getTextModel().setText(Messages.getText("GPSActivityDialog.1"));
		
		final LwTextRender tab2 = new LwTextRender("");
		tab2.setFont(DialogConstants.getDefaultFont());
		tab2.getTextModel().setText(Messages.getText("GPSActivityDialog.2"));
		
		final LwTextRender tab3 = new LwTextRender("");
		tab3.setFont(DialogConstants.getDefaultFont());
		tab3.getTextModel().setText(Messages.getText("GPSActivityDialog.3"));
		
		resp.addPage(tab1, getSatellitePanel());
		resp.addPage(tab2, getDataPanel());
		resp.addPage(tab3, getConsolePanel());
		return resp;
	}
	
	private LwPanel getSatellitePanel() {
		gSatellite = new GPSSatelliteDialog();
		
		LocationProvider provider = GPSResolutor.getLocationProvider();
		if (provider != null) {
			provider.addPropertyChangeListener(gSatellite);
		}
		
		return gSatellite;
	}
	
	private LwPanel getDataPanel() {
		LwPanel panelNorth = new LwPanel();
		panelNorth.setLwLayout(new LwBorderLayout());
		LwPanel panelCenter = new LwPanel();
		panelCenter.setLwLayout(new LwBorderLayout());
		
		LwPanel resp = new LwPanel();
		resp.setLwLayout(new LwBorderLayout());
		
		LwPanel panel1 = new LwPanel();
		panel1.setLwLayout(new LwBorderLayout());

		LwPanel panel2 = new LwPanel();
		panel2.setLwLayout(new LwBorderLayout());

		LwPanel panel3 = new LwPanel();
		panel3.setLwLayout(new LwBorderLayout());
		
		dataPropertiesButton = DialogConstants.getButton("options", "options", this);
		panelNorth.add(LwBorderLayout.EAST, dataPropertiesButton);
		
		txtData1 = DialogConstants.getDefaultTextField();
		txtData2 = DialogConstants.getDefaultTextField();
		txtData3 = DialogConstants.getDefaultTextField();
		
		panel1.add(LwBorderLayout.CENTER, txtData1);
		panel2.add(LwBorderLayout.CENTER, txtData2);
		panel3.add(LwBorderLayout.CENTER, txtData3);
		
		panelCenter.add(LwBorderLayout.NORTH, panel1);
		panelCenter.add(LwBorderLayout.CENTER, panel2);
		panelCenter.add(LwBorderLayout.SOUTH, panel3);
				
		resp.add(LwBorderLayout.NORTH, panelNorth);
		resp.add(LwBorderLayout.CENTER, panelCenter);
		
		return resp;
	}
	
	private LwPanel getConsolePanel() {
		LwPanel resp = new LwPanel();
		
		this.consolePauseButton = DialogConstants.getButton(getBundle(), "gps_console_pause", "gps_console_pause", this);
		this.consoleSaveButton = DialogConstants.getButton(getBundle(), "gps_console_save_2", "gps_console_save_2", this);
		this.consoleStopButton = DialogConstants.getButton(getBundle(), "gps_console_stop", "gps_console_stop", this);
		this.consolePlayButton = DialogConstants.getButton(getBundle(), "gps_console_play", "gps_console_play", this);
		
		resp.setLwLayout(new LwBorderLayout());
		
		LwPanel top = new LwPanel();
		top.setLwLayout(new LwBorderLayout());
		
		LwPanel topCenter = new LwPanel();
		topCenter.setLwLayout(new LwFlowLayout());
		topCenter.add(this.consolePlayButton);
		topCenter.add(this.consolePauseButton);
		topCenter.add(this.consoleStopButton);
		
		LwPanel topRight = new LwPanel();
		topRight.setLwLayout(new LwFlowLayout());
		topRight.add(consoleSaveButton);
		
		top.add(LwBorderLayout.CENTER, topCenter);
		top.add(LwBorderLayout.EAST, topRight);
		
		LwPanel center = new LwPanel();
		LwBorderLayout layout = new LwBorderLayout();
		center.setLwLayout( layout );

		txtConsole = DialogConstants.getDefaultTextField();
		txtConsole.setEditable(false);
		center.add(LwBorderLayout.CENTER, txtConsole);
		
		resp.add(LwBorderLayout.NORTH, top);
		resp.add(LwBorderLayout.CENTER, new LwScrollPan(txtConsole));

		return resp;
	}
	

	/**
	 * Appends raw data received from the GPS to the console
	 * Implements org.dinopolis.gpstool.gpsinput.GPSRawDataListener
	 */
	/*public void gpsRawDataReceived(char[] raw_data, int offset, int length) {
		// Add data received from GPS to the console, if debugging is true
		if (debugging) {
			String text = txtConsole.getText();
			int text_length = text.length();
			// Checks if the console is full and in that case
			// removes some lines from the top
			if (text_length > CONSOLE_SIZE) {
				int ret_pos = text.indexOf(13, CONSOLE_SIZE-text_length);
				text = text.substring(ret_pos+2);
				txtConsole.setText(text);
			}
			txtConsole.write(txtConsole.getText().length(), new String(raw_data,offset,length));
		}
	}*/

	public String getTitle() {
		return Messages.getText("GPSActivityDialog.0");
	}

	
	
	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewPosition(double longitude, double latitude) {
//		activityCanvas.update(this.getGraphics());
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsDisconnected(int origin) {
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewAltitude(double altitude) {
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewSatsUsed(int satUsed) {
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewPDOP(double pdop) {
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewQuality(int quality) {
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewStatus(int status) {
	}

	/**
	 * This method is just included to comply with GPSRelevantEventsListener interface
	 * Implements es.uv.robotica.gvsig.mobile.gps.listener.GPSRelevantEventsListener
	 */
	public void gpsNewHeading(double heading) {
	}

	/**
	 * Returns a new value for the Starfire quality value
	 * @param starfire an integer between 0 and 26
	 */
	public void gpsNewStarfire(int starfire) {
	}

	/**
	 * Returns a new value for the RMS standard deviation of
	 * the ranges inputs for the navigation solution
	 * @param rms a positive double value
	 */
	public void gpsNewRMS(double rms){
	}

	public void fileSelected(String path) {
		File file = new File(path);
		try 
		{
			// write the content of the textarea to an output stream
			PrintWriter out = new PrintWriter(new FileWriter(file));
			String content = txtConsole.getText();
			out.print(content);
            out.close();
		} catch (Exception e) {
			String msg = Messages.getText("GPSActivityDialog.20");
			MessageBox.showDialog(false, bc, msg,
					this, MessageBox.MESSAGE_TYPE_ERROR, MessageBox.MESSAGE_OK);
			e.printStackTrace();
		}
	}
	
	public void locationUpdated(LocationProvider provider, Location location) {
		String extra_info = location.getExtraInfo("application/X-jsr179-location-nmea");
		if (debugging) {
			String text = txtConsole.getText();
			text = text + extra_info; //adds extra_info
			txtConsole.setText(text);
		}
		
		//SECOND TAG
		String message1 = "";
		String message2 = "";
		String message3 = "";
		
		if(gData == null)
		{
			//Default values
			if(GPSDataActivityDialog.defaultPosition == true)
				message1 += "Latitud: " + latitude + "\n" + "Longitud: " + longitude + "\n";
			
			if(GPSDataActivityDialog.defaultAltitude == true)
				message1 +=  "Altitud: " + altitude + " m\n";
		
			if(GPSDataActivityDialog.defaultSpeed == true)
				message1 += "Velocidad: " + speed + " km/h\n";
			
			message2 +="Tiempo: " + date + "\n";
			
			if(GPSDataActivityDialog.defaultHDOP == true)
				message3 += "HDOP: " + hdop + "\n";

			if(GPSDataActivityDialog.defaultVDOP == true)
				message3 += "VDOP: " + vdop + "\n";

			if(GPSDataActivityDialog.defaultHPrecision == true)
				message3 += "HPE: " + hpe + "\n";
			
			if(GPSDataActivityDialog.defaultVPrecision == true)
				message3 += "VPE: " + vpe + "\n";

		}
		else
		{
			if(gData.getPosition() == true)
				message1 += "Latitud: " + latitude + "\n" + "Longitud: " + longitude + "\n";
			
			if(gData.getAltitude() == true)
				message1 += "Altitud: " + altitude + " m\n";
			
			if(gData.getSpeed() == true)
				message1 += "Velocidad: " + speed + " km/h\n";
			
			message2 += "Tiempo: " + date + "\n";
			
			if(gData.getHDOP() == true)
				message3 += "HDOP: " + hdop + "\n";
			
			if(gData.getVDOP() == true)
				message3 += "VDOP: " + vdop + "\n";
			
			if(gData.getHPrecision() == true)
				message3 += "HPE: " + hpe + "\n";
			
			if(gData.getVPrecision() == true)
				message3 += "VPE: " + vpe + "\n";

		}
		
		txtData1.setText(message1);
		txtData2.setText(message2);
		txtData3.setText(message3);

	}
		
	public void providerStateChanged(LocationProvider provider, int newState) {
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		String key = evt.getPropertyName();

		if (key.equals(LocationProperties.TIMESTAMP)) {
			long timestamp = ((Long)evt.getNewValue()).longValue();
			date = new Date(timestamp);
		}
	    else if (key.equals(LocationProperties.LATITUDE)) {
	    	latitude = evt.getNewValue().toString();
	    }
	    else if (key.equals(LocationProperties.LONGITUDE)) {
	    	longitude = evt.getNewValue().toString();
	    }
	    else if (key.equals(LocationProperties.ALTITUDE)) {
			altitude = evt.getNewValue().toString();
	    }
		else if (key.equals(LocationProperties.SPEED)) {
			speed = evt.getNewValue().toString();
		}
		else if (key.equals(LocationProperties.GNSS_HDOP)) {
			hdop = evt.getNewValue().toString();
		}
		else if (key.equals(LocationProperties.GNSS_VDOP)) {
			vdop = evt.getNewValue().toString();
		}
		else if (key.equals(LocationProperties.ERROR_HPE)) {
			hpe = evt.getNewValue().toString();
		}
		else if (key.equals(LocationProperties.ERROR_VPE)) {
		    vpe = evt.getNewValue().toString();
		}
	}
}
