package org.gvsig.mobile.extension.gps.functionality;

import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.gvsig.location.Location;
import org.gvsig.location.LocationListener;
import org.gvsig.location.LocationProvider;
import org.gvsig.location.QualifiedCoordinates;

import org.gvsig.mobile.ui.awt.statusbar.StatusBarDescription;
import org.gvsig.mobile.ui.awt.statusbar.StatusBarLabel;
import org.gvsig.mobile.ui.awt.statusbar.StatusBarManager;
import org.gvsig.mobile.extension.base.layer.raster.Utils;
import org.gvsig.mobile.gps.GPSResolutor;

public class GPSViewCoordinatesFunc extends Functionality implements LocationListener  {
	private static final Logger logger = LoggerFactory.getLogger(GPSViewCoordinatesFunc.class);
	
	private QualifiedCoordinates coordinates = new QualifiedCoordinates(0.0d, 0.0d, 0.0f, Float.NaN, Float.NaN);
	protected static final String BAR_ID = "GPSView_Coordinates_BAR_ID";
	private IGvSigContext gvc;
	
	private StatusBarDescription barDescription;
	private StatusBarLabel xLabel;
	private StatusBarLabel yLabel;
	
	private boolean visible = false;
	
	
	public GPSViewCoordinatesFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			//TODO: Implement this
			//super.stop();
			
			if(visible == false)
				visible = true;
			else
				visible = false;
			
			gvc = (IGvSigContext)bc.getService(gvSIGMobileRef);
			
			if (xLabel == null) {
				xLabel = new StatusBarLabel("...");
			} else {
				xLabel.setText("...");	
			}

			if (yLabel == null) {
				yLabel = new StatusBarLabel("...");
			} else {
				yLabel.setText("...");
			}
			
			if (barDescription == null) {
				barDescription = new StatusBarDescription(StatusBarDescription.PREFERENCE_LOW, BAR_ID);
				barDescription.add(new Integer(50), xLabel);
				barDescription.add(new Integer(50), yLabel);
			}
			
			StatusBarManager sbm = (StatusBarManager) gvc.getStatusBarManager(); 
			sbm.addStatusBar(barDescription);
			
			LocationProvider provider = GPSResolutor.getLocationProvider();
			if (provider != null) {
				// Register cursor as listener for location updates
				provider.addLocationListener(this, 1, LocationProvider.PROVIDER_DEFAULT, 
						LocationProvider.PROVIDER_DEFAULT);
			}
			
			return true;
		} catch (Exception e) {
			logger.error("GPS VIEW COORDINATES ERROR : \n"+e.fillInStackTrace().toString());
			return false;
		}
	}
	
	public void stop() {
		super.stop();
		visible = false;

		if (gvc != null) {
			if (! ((StatusBarManager) gvc.getStatusBarManager()).removeStatusBar(barDescription)) {
				logger.error("Could not remove status bar GPSViewCoordinatesFunc (not found?)");
			}
		} else {
			logger.error("Could not remove status bar GPSViewCoordinatesFunc: IGvSigContext is NULL");
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

	public void locationUpdated(LocationProvider provider, Location location)
	{	
		if(visible == true)
		{
			coordinates = location.getQualifiedCoordinates();
			
			String str = Utils.getFormattedDouble(coordinates.getLongitude(), 6, false) + " " + "";
			String str1 = Utils.getFormattedDouble(coordinates.getLatitude(), 6, false) + " " + "";
					
			if (xLabel == null) {
				xLabel = new StatusBarLabel(str);
			} else {
				xLabel.setText(str);
			}
			
			if (yLabel == null) {
				yLabel = new StatusBarLabel(str1);
			} else {
				yLabel.setText(str1);
			}
		    
			if (barDescription == null) {
				barDescription = new StatusBarDescription(StatusBarDescription.PREFERENCE_LOW, BAR_ID);
				barDescription.add(new Integer(50), xLabel);
				barDescription.add(new Integer(50), yLabel);
			}
		}
	}
	
	public void providerStateChanged(LocationProvider provider,int newState)
	{
	}
}
