package org.gvsig.mobile.extension.gps.functionality;

import org.gvsig.location.LocationProvider;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.extension.gps.GPSCursor;
import org.gvsig.mobile.gps.GPSResolutor;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class GPSViewPositionFunc extends Functionality {

	private GPSCursor gpsCursor = null;

	private static final Logger logger = LoggerFactory.getLogger(GPSViewPositionFunc.class);
	
	public GPSViewPositionFunc() {
		super();
	}
	
	public void configure() {
		// TODO Auto-generated method stub
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			// First time, instantiate the GPS cursor
			if (gpsCursor == null) {
				IGvSigContext gv = (IGvSigContext) bc.getService(gvSIGMobileRef);
				gpsCursor = new GPSCursor((MapControl) gv.getMapControl(), bc.getBundle());
			}

			// If there's a location provider available, subscribe to location updates
			LocationProvider provider = GPSResolutor.getLocationProvider();
			if (provider != null) {
				// Register cursor as listener for location updates
				provider.addLocationListener(gpsCursor, 1, LocationProvider.PROVIDER_DEFAULT, 
						LocationProvider.PROVIDER_DEFAULT);
				provider.addPropertyChangeListener(gpsCursor);
				// provider.addPropertyChangeListener(LocationProperties.COURSE, gpsCursor);
				// provider.addPropertyChangeListener(LocationProperties.COURSE_ESTIMATED, gpsCursor);
			}
			gpsCursor.setVisible(true);
			logger.debug("Cursor shown.");
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}

	public void stop() {
		super.stop();
		// Set cursor visibility
		gpsCursor.setVisible(false);
		LocationProvider provider = GPSResolutor.getLocationProvider();
		if (provider != null) {
			// Unregister cursor as listener for location updates
			provider.removeLocationListener(gpsCursor);
		}
		logger.debug("Cursor hidden.");
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
	}

}
