/*
Copyright 2006 Jerry Huxtable

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package org.gvsig.mobile.extension.wkprojection.jhlabs.map.proj;

/**
 * A geodetic datum. This isn't used (yet).
 */
public class Datum {
	// Just a placeholder for now

	public String name;
	public Ellipsoid ellipsoid;
	public double deltaX, deltaY, deltaZ;
	
		public static final Datum ADINDAN = new Datum("ADINDAN", Ellipsoid.CLARKE_1880, -162, -12, -206);
		public static final Datum ARC1950 = new Datum("ARC1950", Ellipsoid.CLARKE_1880, -143, -90, -294);
		public static final Datum ARC1960 = new Datum("ARC1960", Ellipsoid.CLARKE_1880, -160,  -8, -300);
		public static final Datum AUSGEO1966 = new Datum("Australian Geodetic 1966", Ellipsoid.AUSTRALIAN, -133, -48, 148);
		public static final Datum AUSGEO1984 = new Datum("Australian Geodetic 984", Ellipsoid.AUSTRALIAN, -134, -48, 149);
		public static final Datum CAMPAREAASTRO = new Datum("CAMP_AREA_ASTRO", Ellipsoid.INTERNATIONAL_1967, -104, -129, 239);
		public static final Datum CAPE = new Datum("Cape", Ellipsoid.CLARKE_1880, -136, -108, -292);
		public static final Datum ED50 = new Datum("European Datum 1950", Ellipsoid.INT_1924, -87, -98, -121);
		public static final Datum ED79 = new Datum("European Datum 1979", Ellipsoid.INTERNATIONAL_1967, -86, -98, -119);
		public static final Datum GEO49 = new Datum("Geodetic Datum 1949", Ellipsoid.INTERNATIONAL_1967, 84, -22, 209);
		public static final Datum HK1963 = new Datum("Hong Kong 1963", Ellipsoid.INTERNATIONAL_1967, -156, -271, -189);
		public static final Datum HUTZUSHAN = new Datum("Hu Tzu Shan", Ellipsoid.INTERNATIONAL_1967, -634, -549, -201);

		public static final Datum NAD27 = new Datum("NAD27", Ellipsoid.CLARKE_1866, -8, 160, 176);
		public static final Datum NAD83 = new Datum("NAD83", Ellipsoid.GRS_1980, 0, 0, 0);
		public static final Datum OLDHAWMEA = new Datum("Old Hawaiian mean", Ellipsoid.CLARKE_1866, 89, -279, -183);
		public static final Datum OMAN = new Datum("OMAN", Ellipsoid.CLARKE_1880, -346, -1, 224);
		public static final Datum OS1936 = new Datum("Ordnance Survey 1936", Ellipsoid.AIRY, 375, -111, 431);
		public static final Datum PUERTORICO = new Datum("Puerto Rico", Ellipsoid.CLARKE_1866, 11, 72, -101);
		public static final Datum PULKOVO1942 = new Datum("Pulkovo 1942", Ellipsoid.KRASOVSKY, 27, -135, -89);
		public static final Datum PROVSAMER1956 = new Datum("PROVISIONAL_S_AMERICAN_1956", Ellipsoid.INTERNATIONAL_1967, -288, 175, -376);
		public static final Datum TOKYO = new Datum("Tokyo", Ellipsoid.BESSEL, -128, 481, 664);
		public static final Datum WGS72 = new Datum("WGS72", Ellipsoid.WGS_1972, 0, 0, -4.5);
		public static final Datum WGS84 = new Datum("WGS84", Ellipsoid.WGS_1984, 0, 0, 0);


	public Datum(String name, Ellipsoid ellipsoid, double deltaX, double deltaY, double deltaZ) {
		this.name = name;
		this.ellipsoid = ellipsoid;
		this.deltaX = deltaX;
		this.deltaY = deltaY;
		this.deltaZ = deltaZ;
	}
}
