package org.gvsig.mobile.logging.configure;


import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.FileAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {
	
	public static final String LOG_FILE_NAME="gvSIG.log";
	public static final String LOG_FILE_NAME2="gvSIGconsole.log";

	public void start(BundleContext context) throws Exception {
		long curr = System.currentTimeMillis();

		//File fil = new File("..");
		String direct = System.getProperty("user.home") + File.separator + "gvSIGMobile_logs"; 
		//context.getBundle().getLocation();
		
		String outlogpath = direct +  File.separator + curr + "." + LOG_FILE_NAME;
		String outlogpath2 = direct +  File.separator + curr + "." + LOG_FILE_NAME2;
		System.out.println("Log file: " + outlogpath);

		try {
    		PatternLayout l = new PatternLayout("%5p [%t] - %m%n");
    		FileAppender fa = new FileAppender(l, outlogpath, false);
    		Logger.getRootLogger().setLevel(Level.WARN);
    		//Logger.getRootLogger().setLevel(Level.ERROR);
    		ConsoleAppender ca = new ConsoleAppender(l);
    		
    		Logger.getRootLogger().addAppender(fa);
    		Logger.getRootLogger().addAppender(ca);
    		
    		PrintStream ps = new PrintStream(
    				new BufferedOutputStream(
    				new FileOutputStream(outlogpath2)));
    		
    		//Temporary commented
    		//System.setOut(ps);
    		//System.setErr(ps);

    		System.err.println("SYSTEM.ERR TEST...");
    		System.out.println("SYSTEM.OUT TEST...");
		} catch (Exception ex) {
			System.err.println("Error while initializing logging: " + ex.getMessage());
		}
		
	}

	public void stop(BundleContext context) throws Exception {
		// TODO Auto-generated method stub
		
	}

}
