package org.gvsig.mobile.ui.awt.mapcontrol;

import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;

import org.gvsig.mobile.core.auxfunctions.ShowMessage;
import org.gvsig.mobile.core.interfaces.MapEventsListener;
import org.zaval.lw.LwComponent;
import org.zaval.lw.event.LwMouseEvent;

public class MapEventsThread extends Thread {
	LwComponent eventgenerator;
	LinkedList events = new LinkedList();
	HashSet observers = new HashSet();
	Object lock = new Object();

	public void addListener(MapEventsListener listener) {
		observers.add(listener);
	}

	public void removeListener(MapEventsListener listener) {
		observers.remove(listener);
	}

	public MapEventsThread(MapControl eventgenerator) {
		this.eventgenerator = eventgenerator;
		setName("MapEventsThread");
	}

	public void run() {
		try {
			while (!interrupted()) {
				// esperar al siguiente evento
				synchronized (lock) {

					// Enviar los eventos a todos los listeners
					while (!events.isEmpty()) {
						LwMouseEvent eve = (LwMouseEvent) events.removeFirst();
						Iterator it = observers.iterator();
						while (it.hasNext()) {
							MapEventsListener listener = (MapEventsListener) it
									.next();
							listener.newMouseEvent(eve);
						}
					}
					try {
						lock.wait();
					} catch (InterruptedException e) {
						ShowMessage
								.Show(
										"The MapEvents Thread was interrupted while it was waiting.",
										true);
						ShowMessage
								.Show(
										"This is ok if we are terminating the application.",
										true);
					}
				}
			}
		} catch (java.util.NoSuchElementException e) {
			System.err.println(e.getMessage());
		}
	}

	public synchronized void newEvent(LwMouseEvent eve) {
		synchronized (lock) {
			if (!events.isEmpty() && eve.getID() == LwMouseEvent.MOUSE_DRAGGED) {				
				LwMouseEvent e = (LwMouseEvent) events.getLast();
				if (e.getID() == LwMouseEvent.MOUSE_DRAGGED) {					
					events.removeLast();
				}
			}
			events.addLast(eve);
			lock.notifyAll();
		}
	}

}
