package org.gvsig.mobile.ui.awt.mapcontrol.impl;

import java.awt.geom.Point2D;

import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.handler.Handler;
import org.gvsig.mobile.ui.awt.mapcontrol.snapping.AbstractSnapper;
import org.gvsig.mobile.ui.awt.mapcontrol.snapping.ISnapperVectorial;

/**
 * @author Vicente Caballero Navarro
 */
public class FinalPointSnapper extends AbstractSnapper implements ISnapperVectorial {
	
	public FinalPointSnapper() {
		setPriority(1);
		setEnabled(true);
	}
	
	
	
	public Point2D getSnapPoint(Point2D point, Geometry geom, double tolerance) {
		Point2D resul = null;
		Handler[] handlers = geom.getHandlers(Geometry.SELECTHANDLER);
		//		Point2D initPoint=handlers[0].getPoint();
		//		Point2D endPoint=handlers[handlers.length-1].getPoint();
		//		if (initPoint.equals(endPoint))
		//			return resul;

		double minDist = tolerance;
		//		double dist = initPoint.distance(point);
		//		if (dist < minDist) {
		//			resul = initPoint;
		//			minDist = dist;
		//		}
		//
		//		dist = endPoint.distance(point);
		//		if (dist < minDist) {
		//			resul = endPoint;
		//		}

		for (int j = 0; j < handlers.length; j++) {
			Point2D handlerPoint = handlers[j].getPoint();
			double dist = handlerPoint.distance(point);
			if ((dist < minDist)) {
				resul = handlerPoint;
				minDist = dist;
			}
		}

		return resul;
	}

	public String getToolTipText() {
		return "final_point";
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.fmap.mapcontrol.tools.snapping.snappers.ISnapper#draw(org.gvsig.fmap.mapcontrol.PrimitivesDrawer, java.awt.geom.Point2D)
	 */
//	public void draw(PrimitivesDrawer primitivesDrawer, Point2D pPixels) {
//		primitivesDrawer.setColor(getColor());
//
//		int half = getSizePixels() / 2;
//		primitivesDrawer.drawRect((int) (pPixels.getX() - half),
//				(int) (pPixels.getY() - half),
//				getSizePixels(), getSizePixels());
//	}
}
