package org.gvsig.mobile.ui.awt.statusbar;

import java.util.ArrayList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.zaval.lw.LwComponent;

public class StatusBarDescription {
	
	private static final Logger logger = LoggerFactory.getLogger(StatusBarDescription.class);

	public static final int PREFERENCE_BOTTOM = -10;
	public static final int PREFERENCE_LOW = 0;
	public static final int PREFERENCE_MEDIUM = 1;
	public static final int PREFERENCE_HIGH = 2;
	
	private int preference = PREFERENCE_MEDIUM;
	private ArrayList list = new ArrayList();
	private String id = "";
	
	public StatusBarDescription(int pref, String _id) {
		preference = pref;
		id = _id;
	}
	
	public String getID() {
		return id;
	}
	
	public int getPreference() {
		return preference;
	}
	
	public void setPreference(int p) {
		preference = p;
	}
	
	public ArrayList getComponentsList() {
		return list;
	}
		
	
	public void add(Object o, LwComponent c) {
		
		if (o instanceof Integer) {
			ComponentWidthPair p = new ComponentWidthPair(c, (Integer) o);
			list.add(p);
		} else {
			logger.error("First parameter must be Integer (percentage of width)");
		}
	}
	
	public class ComponentWidthPair {
		
		private Integer width;
		private LwComponent comp;
		
		public ComponentWidthPair(LwComponent c, Integer w) {
			comp = c;
			width = w;
		}
		
		public Integer getWidth() {
			return width;
		}
		
		public LwComponent getComponent() {
			return comp;
		}
		
	}
	
	

}
