/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */
package org.gvsig.mobile.ui.awt.tools;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Vector;

import org.gvsig.i18n.Messages;
import org.gvsig.mobile.core.exceptions.GvSigPropertyNotAttachedException;
import org.gvsig.mobile.core.extensions.interfaces.ITask;
import org.gvsig.mobile.core.extensions.interfaces.ITool;
import org.gvsig.mobile.ui.awt.ImageUtils;
import org.zaval.lw.Layoutable;
import org.zaval.lw.LwAdvViewMan;
import org.zaval.lw.LwBorder;
import org.zaval.lw.LwBorderLayout;
import org.zaval.lw.LwButton;
import org.zaval.lw.LwComponent;
import org.zaval.lw.LwConstraints;
import org.zaval.lw.LwGridLayout;
import org.zaval.lw.LwImgRender;
import org.zaval.lw.LwLabel;
import org.zaval.lw.LwPanel;
import org.zaval.lw.LwScrollPan;
import org.zaval.lw.LwToolkit;
import org.zaval.lw.LwView;
import org.zaval.lw.LwWinLayer;
import org.zaval.lw.event.LwActionListener;

/**
 * This class listen to the events of a DropDownComponent to paint
 * the panel associated to it.
 * @author aromeu
 *
 */
public class ComboStatusListener implements
		org.gvsig.mobile.core.interfaces.TaskStatusListener, LwActionListener {

	private LwComponent parent;
	private LwPanel menu;
	private LwScrollPan panel;
	private Vector tools;

	/**
	 * 
	 * @param parent The DropDownComponent
	 * @param tools The tools of the ToolCombo component
	 */
	public ComboStatusListener(LwComponent parent, Vector tools) {
		this.parent = parent;
		this.tools = tools;
	}	

	public void setTools(Vector tools) {
		this.tools = tools;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.mobile.core.interfaces.TaskStatusListener#taskFinished(org.gvsig.mobile.core.extensions.interfaces.ITask)
	 */
	public void taskFinished(ITask task) {
		LwToolkit.getDesktop(parent).getLayer(LwWinLayer.ID).removeAll();
		// this.mainFrame.remove(menu);
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.mobile.core.interfaces.TaskStatusListener#taskInited(org.gvsig.mobile.core.extensions.interfaces.ITask)
	 */
	public void taskInited(ITask task) {
		try {			
			LwToolkit.getDesktop(parent).getLayer(LwWinLayer.ID).removeAll();
			order();
			LwToolkit.getDesktop(parent).getLayer(LwWinLayer.ID).add(
					createMenu(task));
		} catch (GvSigPropertyNotAttachedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// this.mainFrame.add(menu);
	}

	/**
	 * TODO: Implement this to order the tools as in the toolbar
	 */
	private void order() {
		// if (((DropDownComponent)this.parent).isHelpButton) {
		// final int size = tools.size();
		//			
		// Vector temp = (Vector)tools.clone();
		//			
		// ITool t = null;
		// for(int i = 0; i<size; i++) {
		// t = (ITool)tools.get(i);
		//				
		// temp.remove(temp.indexOf(t));
		//				
		// temp.insertElementAt(t, t.getPosition());
		// }
		// tools = temp;
		// ((DropDownComponent)parent).combo.setTools(temp);
		// }
	}

	/**
	 * Creates the panel with the tools of the ToolCombo
	 * @param task The Functionality of the DropDownComponent
	 * @return The LwPanel. If the panel is higher than the MainFrame
	 * the LwPanel is a LwScrollPan with a vertical scroll component
	 * @throws GvSigPropertyNotAttachedException
	 */
	public LwPanel createMenu(ITask task)
			throws GvSigPropertyNotAttachedException {

		final LwBorder b = new LwBorder(LwBorder.SUNKEN2, Color.white,
				Color.white, Color.white) {
			public void paint(Graphics g, int x, int y, int w, int h,
					Layoutable d) {
				g.setColor(Color.white);
				g.drawRect(x, y, w + 2, h + 2);
			}
		};
		
		menu = new LwPanel();

		menu.getViewMan(true).setBorder(b);

		menu.setLwLayout(new LwGridLayout(tools.size(), 2));

		menu.setLocation(parent.getX() + ToolBarButton.TOOLGROUPCOMPONENT_WIDTH
				- 24, parent.getY() + parent.getHeight());
		menu.setBackground(Color.black);
		final int size = tools.size();
		LwButton l;
		LwLabel l2;
		LwButton l3;
		int width = 0;
		int height = 0;

		LwConstraints cons = new LwConstraints();
		cons.ax = LwToolkit.LEFT;		
		
		ITool tool;		

		for (int i = 0; i < size; i++) {
			l = new LwButton();			
			l.setOpaque(true);
			LwAdvViewMan man = new LwAdvViewMan();

			tool = ((ITool) tools.elementAt(i));

			LwView img = null;
			if(tool.getFuncSolved() != null)
				if(tool.getFuncSolved().isActive())
					img = new LwImgRender(ImageUtils.getResourceImage(tool
							.getBundleContext().getBundle(), tool.getIcon() + ".png.orange"),
							LwView.ORIGINAL);
				else
					img = new LwImgRender(ImageUtils.getResourceImage(tool
							.getBundleContext().getBundle(), tool.getIcon() + ".png.black"),
							LwView.ORIGINAL);
			man.put("bt.on", img);
			man.put("bt.off", img);
			l.setViewMan(man);
			
			l.addActionListener(this);

			l2 = new LwLabel(Messages.getText(tool.getShortDescription()));
			
			l2.setOpaque(true);
			l2.getTextRender().setForeground(Color.white);
			if (LwToolkit.getScreenSize().width > 241)
				l2.getTextRender()
						.setFont((Font) LwToolkit.getStaticObj("f.b"));
			else
				l2.getTextRender().setFont(
						(Font) LwToolkit.getStaticObj("def.fn"));

			menu.add(l);
			menu.setOpaque(true);			
			l3 = new LwButton();
			l3.setLwLayout(new LwBorderLayout());
			l3.add(LwBorderLayout.WEST, l2);

			l3.addActionListener(this);
			l3.setOpaque(true);			

			LwAdvViewMan man1 = new LwAdvViewMan();
			man1.put("bt.on", new LwImgRender(
					ImageUtils.getResourceImage("bg"), LwView.STRETCH));
			man1.put("bt.off", new LwImgRender(ImageUtils
					.getResourceImage("bg"), LwView.STRETCH));

			l3.setViewMan(man1);			

			menu.add(l3);

			if ((int) l.getPreferredSize().width
					+ (int) l2.getPreferredSize().width > width) {
				width = (int) l.getPreferredSize().width
						+ (int) l2.getPreferredSize().width;
			}

			height += (int) l.getPreferredSize().height;
		}

		int screenW = (int) LwToolkit.getDesktop(parent)
				.getLayer(LwWinLayer.ID).getSize().width;
		if (menu.getX() + width > screenW) {
			menu.setLocation(screenW - width - 10, menu.getY());
		}
		menu.setPSSize(width + 5, height + 5);
		menu.setSize(width + 5, height + 5);

		int mainFrameH = parent.getLwParent().getLwParent()
		.getHeight();
		
		if (menu.getHeight() + menu.getY() >= mainFrameH) {
			// System.out.println("return panel");
			
			panel = new LwScrollPan(menu, LwToolkit.VERTICAL);

			// panel.getScrollbar(LwToolkit.VERTICAL).setVisible(false);
			panel.setSOLocation(1, 1);

			panel.getViewMan(true).setBorder(b);

			panel.setLocation(parent.getX()
					+ ToolBarButton.TOOLGROUPCOMPONENT_WIDTH - 24, parent
					.getY()
					+ parent.getHeight());
			panel.setOpaque(true);

			if (panel.getX() + width + 30 > screenW) {
				panel.setLocation(screenW - width - 40, panel.getY());
			}
			panel.setPSSize(width + 25 , mainFrameH - ToolBarButton.TOOLGROUPCOMPONENT_HEIGHT - parent.getHeight());
			panel.setSize(width + 25 , mainFrameH - ToolBarButton.TOOLGROUPCOMPONENT_HEIGHT - parent.getHeight());
			return panel;
		}

		return menu;

	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.mobile.core.interfaces.TaskStatusListener#taskProgress(org.gvsig.mobile.core.extensions.interfaces.ITask, int)
	 */
	public void taskProgress(ITask task, int progress) {
		// TODO Auto-generated method stub
	}

	/**
	 * Listen the events on the panel, gets the tool pressed and calls
	 * DropDownComponent.activateTool with the index of the tool
	 */
	public void actionPerformed(Object arg0, Object arg1) {
		DropDownComponent d = ((DropDownComponent) this.parent);
		Image img = null;
		try {
			img = ImageUtils.getResourceImage(d.getTool().getIcon());
			d.activateTool(((LwButton) arg0).getY() / img.getHeight(null));
			d.stop();
		} catch (GvSigPropertyNotAttachedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
