/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */
package org.gvsig.mobile.ui.awt.tools;

import java.util.Vector;

import org.gvsig.mobile.core.extensions.interfaces.ITool;
import org.gvsig.mobile.tasks.WorkQueue;
import org.zaval.lw.LwComponent;

/*
 * 
 */
public class DropDownComponent extends ToolComponent {

	protected ToolCombo combo;
	protected boolean isHelpButton = false;
//	Color inActiveColor = new Color(0,0,0,160);
//	Color activeColor = inActiveColor;		
	private ComboStatusListener listener;
	
	public DropDownComponent(ToolCombo combo, ITool tool, Vector tools, boolean helpButton) {
		super(tool);			
		this.combo = combo;
		this.isHelpButton = helpButton;
		listener = new ComboStatusListener(this, tools);
		if (tool.getFuncSolved() != null)
			tool.getFuncSolved().addObserver(listener);		
		activeColor = inActiveColor;
		setOpaque(false);		
	}
	
	public void setTools(Vector tools) {
		if(listener != null)
			listener.setTools(tools);
	}
	
	public void start(){		
		if (tool.getFuncSolved() != null)
			WorkQueue.getInstance().execute(tool.getFuncSolved());		
	}

	/*
	 * Stop all tasks initiated by this tool
	 */
	public void stop(){
		if (tool.getFuncSolved() != null)
			tool.getFuncSolved().stop();
	}
	
	public LwComponent getTooltip(LwComponent arg0, int arg1, int arg2) {
		 
		return null;		
	}
	
	public void activateTool(int index) {
		combo.activateTool(index);
	}
}
