package org.gvsig.mobile.ui.awt.tools;

import java.util.Iterator;

import org.gvsig.mobile.animation.Animable;
import org.gvsig.mobile.animation.Animator;
import org.gvsig.mobile.core.extensions.interfaces.IFunctionality;
import org.gvsig.mobile.core.extensions.interfaces.ITask;
import org.gvsig.mobile.core.interfaces.TaskStatusListener;
import org.zaval.lw.LwToolkit;
import org.zaval.lw.LwWinLayer;

public class RollingToolBar extends ToolBar implements TaskStatusListener,
		Animable {
	public RollingToolBar(String key, int alignement) {
		super(key, alignement);
	}

	public void taskInited(ITask task) {
		// do the rock & roll
		if (task instanceof IFunctionality) {
			try {
				LwToolkit.getDesktop(this).getLayer(LwWinLayer.ID).removeAll();
			} catch (Exception e) {
				
			}
			IFunctionality func = (IFunctionality) task;
			ToolComponent tc = null;

			tc = (ToolComponent) tools.get(func.getID());

			int current = tc.getY() / ToolBarButton.TOOLGROUPCOMPONENT_HEIGHT;

			int ms = current * 300;
			if (ms < 500)
				ms = 500;

			Animator.getInstance().subscribe(this, Animator.PROPERTY_Y,
					tc.getY(), ms, true);			
		}
	}

	public void addTool(ToolComponent toolC) {
		IFunctionality f = toolC.getTool().getFuncSolved();
		if (f != null)
			f.addObserver(this);
		super.addTool(toolC);
	}

	public void taskFinished(ITask task) {
	}

	public void taskProgress(ITask task, int progress) {
	}

	public void set(int property, int value) {
		// System.out.println(value);

		Iterator it = order.iterator();
		int maxy = -99999;
		while (it.hasNext()) {
			ToolBarButton gb = (ToolBarButton) it.next();
			int newY = gb.getLocation().y - value;
			gb.setLocation(gb.getLocation().x, newY);
			if (newY > maxy)
				maxy = newY;
		}

		Iterator it2 = order.iterator();

		while (it2.hasNext()) {

			ToolBarButton gb = (ToolBarButton) it2.next();
			if (gb.getLocation().y <= -1 * gb.getHeight()) {
				int newY = maxy + gb.getHeight();
				gb.setLocation(gb.getLocation().x, newY);
				maxy = newY;
			}
		}
	}

	// public void set(int property, int value) {
	// // System.out.println(value);
	// if (property == Animator.PROPERTY_Y) {
	// setLocation(getX(), getY() - value);
	// ToolComponent first = (ToolComponent) order.get(0);
	// // System.out.print(".");
	// while (getY() < 0 && -getY() >= first.getHeight()) {
	// // System.out.print("/");
	// removeTool(first);
	// addTool(first);
	// setLocation(getX(), getY() + first.getHeight());
	// first = (ToolComponent) order.get(0);
	// }
	// recalc();
	// }
	// }

}
