package org.gvsig.mobile.ui.awt.tools;


import java.awt.Dimension;
import java.awt.Graphics;

import org.gvsig.mobile.core.extensions.interfaces.IFunctionality;
import org.gvsig.mobile.core.extensions.interfaces.IToolbar;
import org.gvsig.mobile.ui.awt.ImageUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ToolBarButton extends ToolComponent{
	
	static private Logger logger = LoggerFactory.getLogger(ToolBarButton.class);

	
	public static int TOOLGROUPCOMPONENT_WIDTH = 32;
	public static int TOOLGROUPCOMPONENT_HEIGHT = 24;	
	// public static Image activeIcon = ImageUtils.getResourceImage("fondo_grupo_selected");
	// public static Image inActiveIcon = ImageUtils.getResourceImage("fondo_grupo");
	
	// int padding_top=0;
	// int padding_left=0;
	
	
	public ToolBarButton(IToolbar toolbar) {
		// super(toolbar);
		this.tool = toolbar;
		// we want to be notified when the functionality starts and ends
		IFunctionality f = tool.getFuncSolved();
		if (f != null)
			f.addObserver(this);

		String toolicon = "";
		try {
			toolicon = tool.getIcon();
			this.img_orange = ImageUtils.getResourceImage(
					tool.getBundleContext().getBundle(), toolicon); //  + ".png.orange");
			this.img_black = ImageUtils.getResourceImage(
					tool.getBundleContext().getBundle(), toolicon); //  + ".png.black");
			
			width = this.img_black.getWidth(null);
			height = this.img_black.getHeight(null);
		} catch (Exception ex) {
			logger.error("While getting icon: " + ex.getMessage());
		}
		
		if (width < 0) {
			logger.error("PROBLEM WITH ICON: " + toolicon);
			System.err.println("PROBLEM WITH ICON: " + toolicon);
		}

		setPSSize(width, height);
		setSize(width, height);
		
		this.TOOLGROUPCOMPONENT_HEIGHT = height;
		setOpaque(false);
	}
	
	protected java.awt.Dimension calcPreferredSize(){
		return new Dimension(TOOLGROUPCOMPONENT_WIDTH,TOOLGROUPCOMPONENT_HEIGHT);
	}
	
	
	public void paint(Graphics g){



		if (isActive()){
			g.drawImage(img_black,0,0,null);
		} else {
			g.drawImage(img_black,0,0,null);
		}
	}
}
