/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package org.gvsig.mobile.ui.lw;

import java.awt.Dimension;

import org.gvsig.i18n.Messages;
import org.gvsig.mobile.ui.awt.IWindowInfo;
import org.gvsig.mobile.ui.awt.WindowManager;
import org.zaval.lw.LwBorderLayout;
import org.zaval.lw.LwComponent;
import org.zaval.lw.LwPanel;
import org.zaval.lw.event.LwActionListener;

public class ColorChooserDialog extends LwPanel implements IWindowInfo, LwActionListener {
	
	private ColorPanel colorPanel;
	private ColorChooserListener colorListener;
	private OkCancelComposite okComposite;
	private LwComponent comp;
	
	public ColorChooserDialog(LwComponent _comp, ColorChooserListener c) {
//		super(false);
		this.buildMainPanel();
		this.colorListener = c;
		comp = _comp;
		colorPanel.setSelectedColor(comp.getBackground());
	}

	public void actionPerformed(Object arg0, Object arg1) {
		if(arg0 == okComposite.getOkButton()) {			
			this.colorListener.colorSelected(comp, colorPanel.getSelectedColor());
			WindowManager.getInstance().closeActivePanel();
		} else if (arg0 == okComposite.getCancelButton()) {
			WindowManager.getInstance().closeActivePanel();
		}		
	}

	private LwPanel buildMainPanel() {
		this.setLwLayout(new LwBorderLayout());
		colorPanel = new ColorPanel();	
		this.add(LwBorderLayout.CENTER, colorPanel);
		okComposite = new OkCancelComposite(this);
		this.add(LwBorderLayout.SOUTH, okComposite);
		return colorPanel;
	}

	public String getTitle() {
		return Messages.getText("ColorChooser.0");
	}
	
	public void showDialog() {
		WindowManager.getInstance().show(this, this.getTitle());
	}

	public Dimension getDesiredSize() {
		// TODO Auto-generated method stub
		return new Dimension(colorPanel.getPreferredSize().width , 
				colorPanel.getPreferredSize().height 
				+ okComposite.getPreferredSize().height
				+ DialogConstants.getTitleHeight() + 10);
	}

	public boolean isMaximized() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean catchInput(LwComponent arg0) {
		// TODO Auto-generated method stub
		return false;
	}
}
