/**
 *     Caption: J2SE/J2ME(Personal Profile) Light-Weight Visual Components Library
 *
 *     @author:     Andrei Vishnevsky
 *     @version:    4.50
 *
 * The latest product version is always available from the product's homepage:
 * http://www.lwvcl.com/
 *
 * Copyright (C) 2001-2005  Zaval Creative Engineering Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
package org.zaval.lw.misc;

import java.util.Hashtable;

import org.zaval.lw.LwComponent;
import org.zaval.lw.event.LwMouseEvent;
import org.zaval.lw.event.LwVCLEvent;



public class LwCustomGridEditor
implements org.zaval.lw.grid.LwEditorProvider
{
   private Hashtable editors = new Hashtable();

   public void setColEditor (int col, LwComponent editor) {
     editors.put(new Integer(col), editor);
   }

   public LwComponent getEditor(int row, int col, Object data)
   {
     LwComponent editor = null;
     if (data instanceof CItem) editor = ((CItem)data).getEditor();
     if (editor == null) editor = (LwComponent)editors.get(new Integer(col));

     if (editor != null && LwUtils.fillEditorByData(data, editor))
       return editor;

     return null;
   }

   public Object fetchEditedValue (int row, int col, Object data, LwComponent editor)
   {
     Object value = LwUtils.fetchEditedData (data, editor);
     if (data instanceof CItem)
     {
       ((CItem)data).resetValue(value);
       return data;
     }
     return value;
   }

   public boolean shouldStartEdit(int row, int col, LwVCLEvent e) {
     return e.getID() == LwMouseEvent.MOUSE_CLICKED && ((LwMouseEvent)e).getClickCount() > 1;
   }
}
