/**
 *     Caption: J2SE/J2ME(Personal Profile) Light-Weight Visual Components Library
 *
 *     @author:     Andrei Vishnevsky
 *     @version:    4.50
 *
 * The latest product version is always available from the product's homepage:
 * http://www.lwvcl.com/
 *
 * Copyright (C) 2001-2005  Zaval Creative Engineering Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
package org.zaval.lw.misc;

import java.awt.Color;
import java.util.Hashtable;

import org.zaval.lw.LwToolkit;
import org.zaval.lw.LwView;

public class LwCustomGridView
extends LwGenericView
implements org.zaval.lw.grid.LwGridViewProvider
{
  private int       defAx = LwToolkit.CENTER, defAy = LwToolkit.CENTER;
  private Hashtable props = new Hashtable();

  public void setDefAlignments(int ax, int ay)
  {
    if (ax != LwToolkit.CENTER && ax != LwToolkit.LEFT && ax != LwToolkit.RIGHT)
      throw new IllegalArgumentException();

    if (ay != LwToolkit.CENTER && ay != LwToolkit.TOP && ay != LwToolkit.BOTTOM)
      throw new IllegalArgumentException();

    defAx = ax;
    defAy = ay;
  }

  public void setColProperties(int col, int ax, int ay, Color color) {
    props.put (new Integer(col), new Object[] { new Integer(ax), new Integer(ay), color });
  }

  public Color getCellColor(int row, int col) {
    Object[] p = (Object[])props.get (new Integer(col));
    return p == null?null:(Color)p[2];
  }

  public int getXAlignment (int row, int col) {
    Object[] p = (Object[])props.get (new Integer(col));
    return p == null?defAx:((Integer)p[0]).intValue();
  }

  public int getYAlignment (int row, int col) {
    Object[] p = (Object[])props.get (new Integer(col));
    return p == null?defAx:((Integer)p[1]).intValue();
  }

  public LwView getView(int row, int col, Object obj) {
    if (obj == null) return null;
    return getView (obj);
  }
}

