/**
 *     Caption: J2SE/J2ME(Personal Profile) Light-Weight Visual Components Library
 *
 *     @author:     Andrei Vishnevsky
 *     @version:    4.50
 *
 * The latest product version is always available from the product's homepage:
 * http://www.lwvcl.com/
 *
 * Copyright (C) 2001-2005  Zaval Creative Engineering Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
package org.zaval.lw.misc;

import java.awt.Color;

import org.zaval.lw.LwCompRender;
import org.zaval.lw.LwToolkit;
import org.zaval.lw.LwView;
import org.zaval.lw.grid.LwGridViewProvider;

public class LwGridCompView
implements LwGridViewProvider
{
  private LwCompRender render;

  public LwGridCompView() {
    render = new LwCompRender(null);    
  }

  public Color getCellColor (int row, int col) {
    return Color.white;
  }

  public int getXAlignment (int row, int col) {
    return LwToolkit.CENTER;
  }

  public int getYAlignment (int row, int col) {
    return LwToolkit.CENTER;
  }

  public LwView getView(int row, int col, Object o) {
    render.setTarget(o);
    return render;
  }
}
